<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:v="urn:schemas-microsoft-com:vml">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8"/>
<?php
	$names = array(
		'addressee',
		'address',
		'state',
		'city',
		'country',
		'zip',
		'telephone',
		'fax',
		'mobile', 
		'msn',
		'skype', 
		'icq', 
		'aol', 
		'ym', 
		'google', 
		'latitude', 
		'longitude'
	);
	
	$data = array();
	foreach ($names as $name)
		$data[ $name ] = addslashes(/*htmlentities(utf8_decode(*/@$_GET[$name]/*), ENT_QUOTES, 'UTF-8')*/);
		
	foreach ($names as $name)
		$lang[ $name ] = addslashes(/*htmlentities(utf8_decode(*/@$_GET['lang'][$name]/*), ENT_QUOTES, 'UTF-8')*/);

	$data['show'] = @$_GET['show'];

	$address 	= $data['address'];
	$city 		= $data['city']; 
	$state 		= $data['state']; 
	$country 	= $data['country'];
	
	$fieldId = (int)@$_GET['fid'];
	
	$markerText = '';
	
	if( isset($data['show']) && count($data['show'])>0 ){
	    $markerText = '<table>';
	
    	foreach ($data['show'] as $k => $v) {
    		if (!$v)
    			continue;
    		
    		if ($k == 'latitude' && isset($_GET['hideLatitude']))
    			continue;
    		
    		if ($k == 'longitude' && isset($_GET['hideLongitude']))
    			continue;
    		
    			
    		$markerText .= '<tr><td>'.$lang[ $k ].': </td><td>'.$v.'</td></tr>';
    	}
    	$markerText .= '</table>';
	}
?>
<title><?php echo stripslashes(strip_tags($markerText)); ?></title>
<script src="http://maps.google.com/maps?file=api&amp;v=2.x<?php if( @$_GET['google_map_key'] != "" ) {  echo  '&amp;key=' . $_GET['google_map_key'];} ?>" type="text/javascript"></script>
<script type="text/javascript">
    var AddrMap;
    //var marker = null;
    var AddrGeocoder;
	
	function initialize() {
  		if (GBrowserIsCompatible()) {
     		AddrMap = new GMap2(document.getElementById("map_canvas"));
     		AddrGeocoder = new GClientGeocoder();

     
		    /*set type map: G_HYBRID_MAP, G_NORMAL_MAP, G_SATELLITE_MAP*/
		    AddrMap.setMapType(<?php echo $_GET['map_type']; ?>);
		 	showAddress("<?php echo $address; ?>  <?php echo $city;?> <?php echo $state; ?> <?php echo $country; ?>");
			

			var mapTypeControl = new GMapTypeControl();

			var topRight = new GControlPosition(G_ANCHOR_TOP_RIGHT, new GSize(5,5));
			if( (<?php echo $_GET['controls']; ?>) != 0) {
	   			AddrMap.addControl(mapTypeControl, topRight);
			}
			if( (<?php echo $_GET['controls']; ?>) != 0 ) {
				AddrMap.addControl(new GSmallMapControl());
			}
  		}
	}

	function showAddress(address) {
		<?php if (isset($data['latitude'], $data['longitude']) && !empty($data['latitude']) && !empty($data['longitude'])) : ?>
		var p = new GLatLng(<?php echo $data['latitude'], ', ', $data['longitude']; ?>);
		if (p) {
			showLocation(p, address);
			return;
		}
		<?php endif; ?>
		if (AddrGeocoder) {
    		AddrGeocoder.getLatLng(
      			address,
      			function(point) {
        			if (!point) {
          				alert(address + " not found");
        			} else {
         				showLocation(point, address);
        			}
      			}
    		);
  		}
	}
	
	function showLocation(point, address) {
		AddrMap.setCenter(point, <?php echo $_GET['zoom']; ?>);
	    <?php if (@$_GET['show_marker']){ ?>
	    	var marker = new GMarker(point);
	    	AddrMap.addOverlay(marker);
	    <?php if (!empty($markerText)) {?>	marker.openInfoWindowHtml("<?php echo $markerText; ?>");<?php }?>
	    <?php }?>
	    document.getElementById('map_canvas').style.border = '1px solid black';
	}
</script>
<style>
	#map_canvas {
		border-right: 1px solid black;
		border-bottom: 1px solid black;
	}
</style>
</head>

<body onload="initialize()"  onunload="GUnload()">
  <div id="map_canvas" style="width: <?php echo $_GET['map_width'];?>px; height: <?php echo $_GET['map_height']; ?>px;border: 1px solid black; float: rigth;" ></div>
</body>
</html>
