<?php
/**
 * @fileID: $Id: audio.php 7420 2011-11-01 08:05:28Z kostya $
 * @changedDate: $LastChangedDate: 2011-11-01 15:05:28 +0700 (Вт, 01 ноя 2011) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ( '_JEXEC' ) or die ( 'Restricted access' );

jimport ( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsAudio extends JPlugin
{
    function plgJoomsuite_content_fieldsAudio(&$subject, $params)
    {
        parent::__construct ( $subject, $params );
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'jsfilemanager.php';
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
    }

    function onRenderField(&$obj, &$params, $type)
    {
        if ($type != 'audio')
            return;

        $exts = 'mp3';
        switch ($params->get ( 'type' ))
        {
            case 1 :

                require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
                $fileHelper = & JS_File_Helper::getInstance();

                echo '<input style="width:', $params->get ( 'field_size' ), '" type="file" name="files[', $obj->id, ']" />';


                $authorId = $fileHelper->getRecordOwner($obj->record_id);
                echo '<input type="hidden" name="fields[author][', $obj->id, ']" value="', $authorId, '"/>';
                break;

            case 2 :
                       ?>
<input style="width:<?php
                       echo $params->get ( 'field_size' )?>" type="text"
       name="fields[<?php
                       echo $obj->id?>]" value="<?php
                       echo $obj->field_value?>" />
                       <?php
                       if ($params->get ( 'type' ) == 2)
                           echo '<br />' . JText::_ ( 'Insert full path including http://.' );
                break;
                    case 3 :
                        $filter = explode ( ", ", $exts );
                        ?>
<select style="width:<?php
                            echo $params->get ( 'field_size' )?>" name="fields[<?php
                            echo $obj->id;
                ?>]" class="inputbox" size="1">
                <?php
                echo implode ( "\n", ResViewRecord::files ( $params->get ( 'directory' ), $params, $obj->field_value, $filter ) );
                ?>
</select>
                <?php
                break;
        } // end switch

        if ($obj->field_value && ($params->get ( 'type' ) == 1))
        {
            echo '<br /><input type="checkbox" value="1" name="remove[' . $obj->id . ']" value="' . $obj->field_value . '" />' . JText::_ ( 'Remove Current' );
            echo " ({$obj->field_value})";
            echo "<input type=\"hidden\" name=\"fields[{$obj->id}]\" value=\"{$obj->field_value}\" />";
        }
        echo '<br />' . JText::_ ( 'Allowed formats are' ) . ": $exts";
    }

    function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
    {

        if ($type != 'audio')
            return;

        $db = &JFactory::getDBO ();
        $value = $db->getEscaped ( $value );

        jimport ( 'joomla.filesystem.file' );
        jimport ( 'joomla.filesystem.folder' );

        require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
        ResControllerConfig::initialyze ();
        $post = JRequest::get('POST');
        $files = JRequest::get("FILES");
        if (isset ( $post ['remove'] [$id] ) && $post ['remove'] [$id])
        {
            JFile::delete ( RES_GENERAL_UPLOAD . DS . $row->user_id   . DS .'audio'. DS . $value );
            $value = '';
        }

        $error = true;

        switch ($params->get ( 'type' ))
        {
            case 1:
                if (isset ( $files ['files'] ['name'] [$id] ) && $files ['files'] ['name'] [$id])
                {

                    $tmp_name = $files ['files'] ['tmp_name'] [$id];
                    $name	= JFile::makeSafe($files['files']['name'][$id]);

                    if( ! $this->checkDirectory ( RES_GENERAL_UPLOAD ) )
                        return;

                    $folder = RES_GENERAL_UPLOAD . DS .(int) $row->user_id;

                    if( !$this->checkDirectory ( $folder ) )
                        return;

                    $folder .= DS . 'audio' ;

                    if( !$this->checkDirectory ( $folder ) )
                        return;
                    if( !$this->checkExtention( $name ) )
                        return;
                    if( !$this->checkFileSize( $id, $params, $name ) )
                        return;
                    if ( $params->get ( 'attach' ) )
                    {
                        $name = time() . '_' . $name;
                    }

                    $value = $db->getEscaped ( $name );
                    $dest = $folder . DS . $name;

                    if( !$this->checkOvewriteRestriction( $dest, $params, $name ) )
                        return;
                    if( !$this->tryToUpload( $tmp_name, $dest, $name ) )
                        return;
                }

                break;
            case 2:

                break;
            case 3:

                break;
        }

        $error = false;
    }

    function onArticleAuthorChange(&$records, $newAuthor)
    {

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';

        $fileHelper = JS_File_Helper::getInstance();
        $fileHelper->reassignFilesOld($records, $newAuthor, 'audio');
    }

    function tryToUpload( $tmp_name, $dest, $name )
    {
        if (! JFile::upload ( $tmp_name, $dest ))
        {
            $msg = JText::_ ( "Could not upload the file" );
            $msg .= "<br />" . JText::_( 'File' ) . ": " . $name;
            JError::raiseWarning ( 403, $msg );
            return false;
        }
        return true;
    }

    function checkOvewriteRestriction( $dest, &$params, $name )
    {
        if ( JFile::exists ( $dest ) && ! $params->get ( 'overwrite' ) )
        {
            $msg = JText::_ ( "This File already Exists" );
            $msg .= "<br />" . JText::_( 'File' ) . ": " . $name;
            JError::raiseWarning ( 403, $msg );
            return false;
        }
        return true;
    }

    function checkFileSize( $id, &$params, $name )
    {
    	$files = JRequest::get("FILES");
        $size = $files['files']['size'][$id];
        $maxFileSize = $params->get ( 'max' ) * 1024;

        if (($size > $maxFileSize) && $maxFileSize)
        {
            $msg = JText::_ ( "File size exceed allowed" );
            $msg .= "<br />" . JText::_( 'File' ) . ": " . $name;
            $msg .= "<br />" . JText::_( 'Size' ) . ": " . number_format ( $size, 0, '', ',' );
            $msg .= "<br />" . JText::_( 'Allowed Size' ) . ": " . number_format ( $params->get ( 'max' ), 0, '', ',' );
            JError::raiseWarning ( 403, $msg );
            return false;
        }
        return true;
    }

    function checkExtention( $name )
    {
        $exts = array ( 'mp3' );
        $ext = strtolower ( substr ( $name, strrpos ( $name, '.' ) + 1 ) );

        if (! in_array ( $ext, $exts ))
        {
            $msg = JText::_ ( "File is not in appropriate format" );
            $msg .= "<br />" . JText::_( 'File' ) . ": " . $name;
            $msg .= "<br />". JText::_ ( 'Allowed formats are' ) . ": " . implode ( ", ", $exts );
            JError::raiseWarning ( 403, $msg );
            return false;
        }
        return true;
    }

    function checkDirectory( $folder )
    {
        if ( !JFolder::exists ( $folder ) )
        {
            if ( !JFolder::create ($folder, 0755) )
            {
                $message = JText::_ ( 'Cannot upload file, Please, check upload directory is correct and accessible' );
                $message .= "<br />". JText::_ ( 'Folder' ) . ": " . $folder;
                JError::raiseWarning ( 403, $message );
                return false;
            }
        }
        return true;
    }

    /**
     * Cleanup the uploaded files
     * @param $recordIds
     * @return unknown_type
     */
    function onDeleteRecords($recordIds)
    {
        jimport ('joomla.filesystem.file');

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        $db = & JFactory::getDBO();

        $q = 'SELECT r.id AS record_id, f.params, rv.field_value, r.user_id FROM '.
                '#__js_res_record r '.
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                'WHERE '.
                'r.id IN ('.implode(' , ',$recordIds).') AND f.type = "audio"';

        $db->setQuery( $q );
        $recs = $db->loadObjectList();

        foreach ($recs as $rec)
        {
            if (empty($rec->user_id) || empty($rec->record_id) || empty($rec->field_id))
                continue;

            $params = new JParameter($rec->params);
            if ($params->get('type') == 1)
            {
                $file = $rec->field_value;
                $file = JPath::clean(RES_GENERAL_UPLOAD .DS .$rec->user_id .DS .'audio'. DS. JFile::makeSafe($file));
                $fileHelper = JS_File_Helper::getInstance();
                $fileHelper->removeFiles($file);
                
            }
        }
    }

    function onRenderFieldValue(&$out, &$field, &$record, $category)
    {
        if ($field->type != 'audio') return;
        if (! $field->field_value) return;

        $params = new JParameter($field->params);
        $user = $record->user_id;
        $type = $field->type;
        $fileManager = &JSFileManager::getInstance();


        global $mainframe;
        $file = '';
        require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
        ResControllerConfig::initialyze ();

        switch ($params->get ( 'type' ))
        {
            case 1 :
                $mp3 = JURI::root().$fileManager->getDownloadUrl($field->id);
                $file = RES_GENERAL_UPLOAD.DS.$record->user_id.DS.'audio'.DS.$field->field_value;
               break;
            case 2 :
                $mp3 = sprintf ( '%s', $field->field_value );
                break;
            case 3 :
                $mp3 = JURI::root().$fileManager->getDownloadUrl($field->id);
                $file = JPATH_ROOT.DS.$field->field_value;
                break;

        }
        
        JHTML::_('behavior.mootools');

        $document = &JFactory::getDocument ();
        $document->addScript ( JURI::root().'plugins/joomsuite_content_fields/audio.js' );

        $out [] = '<p id="player' . $field->id . '">'.JText::_ ( '<a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see this player.' ).'</p>';
        $out [] = '<script type="text/javascript">';
        $out [] = sprintf ( 'var s%d = new SWFObject("'.JURI::root().'plugins/joomsuite_content_fields/audio.swf", "line", "%d", "%d", "7" );', $field->id, $params->get ( 'width' ), $params->get ( 'height' ) );
        $out [] = sprintf ( 's%d.addVariable("file","%s");', $field->id, urlencode($mp3) );
        if ($params->get ( 'backcolor' ))
            $out [] = sprintf ( 's%d.addVariable("backcolor","0x%s");', $field->id, $params->get ( 'backcolor' ) );
        if ($params->get ( 'frontcolor' ))
            $out [] = sprintf ( 's%d.addVariable("frontcolor","0x%s");', $field->id, $params->get ( 'frontcolor' ) );
        if ($params->get ( 'lightcolor' ))
            $out [] = sprintf ( 's%d.addVariable("lightcolor","0x%s");', $field->id, $params->get ( 'lightcolor' ) );
        if ($params->get ( 'skin' ))
            $out [] = sprintf ( 's%d.addVariable("skin","'.JURI::root().'plugins/joomsuite_content_fields/audio_skins/%s");', $field->id, $params->get ( 'skin' ) );
        
        $out [] = sprintf ( 's%d.addVariable("autostart","false")', $field->id );
        $out [] = sprintf ( 's%d.addVariable("controlbarsize","20");', $field->id );
        $out [] = sprintf ( 's%d.addVariable("type","sound");', $field->id );

        $out [] = sprintf ( 's%d.addParam("allowfullscreen","true");', $field->id );
        $out [] = sprintf ( 's%d.addParam("allowscriptaccess","always");', $field->id );
        $out [] = sprintf ( 's%d.addParam("wmode","opaque");', $field->id );

        $out [] = sprintf ( 's%d.addVariable("repeat","true");', $field->id );
        $out [] = sprintf ( 's%d.addVariable("showdigits","true");', $field->id );
        $out [] = sprintf ( 's%d.addVariable("showdownload","true");', $field->id );
        $out [] = sprintf ( 's%d.addVariable("width","%d");', $field->id, $params->get ( 'width' ) );
        $out [] = sprintf ( 's%d.addVariable("height","%d");', $field->id, $params->get ( 'height' ) );

        $out []  = 'Window.addEvent("domready", function() { '.
                sprintf( 's%d.write("player%d");', $field->id, $field->id ).
                '});'.
                'Window.addEvent("load", function(){ '.
                'if ($E("#player' . $field->id . ' a"))'.
                sprintf( 's%d.write("player%d");', $field->id, $field->id ).
                '});';

        $out [] = '</script>';

        $add = array ();


        if ($params->get ( 'show_name' ))
        {
        	if( in_array( $params->get ( 'type' ), array( 1, 3 ) ) ){
            	$add [JText::_ ( 'File' )] = JHTML::link(JURI::root().$fileManager->getDownloadUrl($field->id), basename($file));
        	}else{
            	$add [JText::_ ( 'File URL' )] = JHTML::link($field->field_value , $field->field_value );
        	}
        }

        if ( in_array( $params->get ( 'type' ), array( 1, 3 ) ) && $params->get ( 'tags' ))
        {
            if (JFile::exists ( $file ) )
            {

                require_once (JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'audio_parser.php');
                $parser = new MP3_Id ( );
                $parser->read ( $file );
                $parser->_readframe ();

                if ($params->get ( 'show_title' ) && $parser->getTag ( 'name' ))
                {
                    $add [JText::_ ( 'Title' )] = $parser->getTag ( 'name' );
                }
                if ($params->get ( 'show_track' ) && $parser->getTag ( 'track' ))
                {
                    $add [JText::_ ( 'Title' )] = sprintf ( '(%d) %s', $parser->getTag ( 'track' ), $add [JText::_ ( 'Title' )] );
                }
                if ($params->get ( 'show_bitrate' ) && $parser->bitrate)
                {
                    $add [JText::_ ( 'Bitrate' )] = $parser->bitrate . ' Kbps';
                }
                if ($params->get ( 'show_length' ) && $parser->length)
                {
                    $add [JText::_ ( 'Length' )] = $parser->length;
                }
                if ($params->get ( 'show_size' ) && $parser->musicsize)
                {
                    $add [JText::_ ( 'Size' )] = $this->jsFormatSize ( $parser->musicsize );
                }

                if ($params->get ( 'show_year' ) && $parser->getTag ( 'year' ))
                {
                    $add [JText::_ ( 'Year' )] = $parser->getTag ( 'year' );
                }
                if ($params->get ( 'show_artist' ) && $parser->getTag ( 'artist' ))
                {
                    $add [JText::_ ( 'Artist' )] = $parser->getTag ( 'artist' );
                }
                if ($params->get ( 'show_album' ) && $parser->getTag ( 'album' ))
                {
                    $add [JText::_ ( 'Album' )] = $parser->getTag ( 'album' );
                }
                if ($params->get ( 'show_genre' ) && $parser->getTag ( 'genre' ))
                {
                    $add [JText::_ ( 'Genre' )] = $parser->getTag ( 'genre' );
                }
                if ($params->get ( 'show_comments' ) && $parser->getTag ( 'comments' ))
                {
                    $add [JText::_ ( 'Author' )] = $parser->getTag ( 'comments' );
                }
            } else
            {
                $out[] = JText::sprintf( "<b>File not found on server. Please notify administrator by %s</b>", '<a href="mailto:'.$mainframe->getCfg( 'mailfrom' ).'">'.$mainframe->getCfg( 'mailfrom' ).'</a>' );
            }
        }
        if ( count ( $add ) > 0 )
        {
            $out [] = '<table border="0" cellpadding="2" cellspacing="0">';
            foreach ( $add as $lable => $value )
            {
                $out [] = "<tr class=small><td>$lable </td><td> $value</td></tr>";
            }
            $out [] = '</table>';
        }
        $out = implode ( "\n", $out );
    }
    function jsFormatSize($size)
    {

        $kb = 1024;
        $mgb = $kb * 1024;
        $gb = $mgb * 1024;
        $trb = $gb * 1024;

        if ($size > $trb)
        {
            return number_format ( $size / $trb, 2, ',', ' ' ) . " Tb";
        } elseif ($size > $gb)
        {
            return number_format ( $size / $gb, 1, ',', ' ' ) . " Gb";
        } elseif ($size > $mgb)
        {
            return number_format ( $size / $mgb, 0, ',', ' ' ) . " Mb";
        } elseif ($size > $kb)
        {
            return number_format ( $size / $kb, 0, ',', ' ' ) . " Kb";
        } else
        {
            return $size . " B";
        }
    }

    function onDownloadFile($field, $recordValue)
    {
        if($field->type != 'audio'){return;}
        
        $user = &JFactory::getUser();
        $pathData = new stdClass();
        $fileHelper = &JS_File_Helper::getInstance();
        $params = new JParameter($field->params);
        $file = $recordValue->field_value;
       
        $dir = RES_GENERAL_UPLOAD.DS.$field->user_id.DS.'audio';
        
        if($fileHelper->checkSubscription($field->params))
        {
            if($params->get('type') == 1)
            {
                $pathData->path = $dir.DS.$file;
            }
            else if ($params->get('type') == 3)
            {
                $pathData->path = JPATH_ROOT.DS.$file;
            }
            $params = new JParameter($field->params);
            $fileHelper->modifyUsersCarma($field->params, $field->user_id, $user->get('id'));
        }
        else 
        {
        	/*$link = JRoute::_('index.php?option=com_jcs&view=jcs&id='.implode(',', $params->get('viewSp', array())).'&Itemid='.$params->get('itemid'));
        	JRequest::setVar('redirect', base64_encode($link));*/
        	$pathData->error = JText::_("The file is under subscription");
        	$pathData->path = null;
        }
        return $pathData;

    }
}
?>