<?php
/**
 * Element that 
 * @author Nurlan
 *
 */
class JElementJSAddress extends JElement 
{
	function JSAddress() {
		parent::__construct();
	}
	
	function fetchElement($name, $value, &$node, $control_name) {
		$juserExists = $this->pingJUser();
		if ($juserExists) {
			$fields = & $this->getFieldNames();
			
			$options = array();
			$options[] = JHTML::_('select.option', '', 0);
			foreach ($fields as $f) {
				$options[] = JHTML::_('select.option', $f->id, $f->title);
			}
		}
		
		return 
			'<style>td.paramlist_key, td.paramlist_value {white-space: nowrap}</style>'.
			JHTML::_('select.booleanlist', $control_name.'['.$name.'][ 0 ]', null, @$value[ 0 ]). ' '.
			'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.JText::_('Show in GMap'). ' ' .JHTML::_('select.booleanlist', $control_name.'['.$name.'][ 1 ]', null, empty($value[ 1 ]) ? null : $value[ 1 ]).
			($juserExists ?  
			'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.JText::_('JUser field').' '. 
			JHTML::_('select.genericlist', $options, $control_name.'['.$name.'][ 2 ]', null, 'value', 'text', empty($value[ 2 ]) ? null : $value[ 2 ]) : '');
	}
	
	function & getFieldNames() {
		static $fields = array();
		static $defaultFields = array();
		
		if (!$defaultFields) {
			$names = array('Username', 'Name', 'Email');
			
			foreach ($names as $name) {
				$a = new stdClass;
				$a->id = $a->title = $name;
				$defaultFields[] = $a; 
			}
		}
		
		if (!$fields) {
			$db = & JFactory::getDBO();
			
			$q = 'SELECT id, title FROM #__juser_extended_fields';
			$db->setQuery( $q );
			$res = $db->loadObjectList();
			settype($res, 'array');
			$fields = array_merge($defaultFields, $res);
		}
		return $fields;
	}
	
	function pingJUser() {
		jimport ('joomla.filesystem.file');
		return JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'juser.php');
	}
}

?>