<?php
/**
 * Element that 
 * @author Nurlan
 *
 */
class JElementJSText extends JElement 
{
	function JSText() {
		parent::__construct();
	}
	
	function fetchElement($name, $value, &$node, $control_name) {
		$juserExists = $this->pingJUser();
		if ($juserExists) {
			$fields = & $this->getFieldNames();
			
			$options = array();
			$options[] = JHTML::_('select.option', '', 0);
			foreach ($fields as $f) {
				$options[] = JHTML::_('select.option', $f->id, $f->title);
			}
		}
		return 
			'<style>td.paramlist_key, td.paramlist_value {white-space: nowrap}</style>'.
			($juserExists ? JHTML::_('select.genericlist', $options, $control_name.'['.$name.']', null, 'value', 'text', empty($value) ? null : $value) : '');
	}
	
	function & getFieldNames() {
		static $fields = 0;
		static $defaultFields = 0;
		
		if (!$defaultFields) {
			$defaultFields = array();
			$names = array('Username', 'Name', 'Email');
			
			foreach ($names as $name) {
				$a = new stdClass;
				$a->id = $a->title = $name;
				$defaultFields[] = $a; 
			}
		}
		
		if (!$fields) {
			$db = & JFactory::getDBO();
			
			$q = 'SELECT id, title FROM #__juser_extended_fields';
			$db->setQuery( $q );
			$fields = array_merge($defaultFields, $db->loadObjectList());
		}
		return $fields;
	}
	
	function pingJUser() {
		jimport ('joomla.filesystem.file');
		return JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'juser.php');
	}
}

?>