<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsNotifyUser extends JPlugin
{
	function plgJoomsuite_content_fieldsNotifyUser( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	function onRenderField(&$obj, &$params, $type)
	{
		if ($type != 'notifyuser') 
			return;

		$value = $obj->field_value;
		$db = &JFactory::getDBO();
		
		$sql = 'SELECT a.name AS text,  a.id AS value '
			. "\n FROM #__users AS a  "
			. "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = a.id"
			. "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id"
			. "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id AND g.id = ".$params->get('group_id', 20)
			. "\n WHERE a.block = 0"
			;
		$sql = $db->setQuery($sql);
		$users  = $db->loadObjectList();
		echo JHTML::_('select.genericlist',  $users, "fields[$obj->id]", 'class="inputbox"', 'value', 'text', $value);
		
	}
	
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'notifyuser') return;
		if(!$value) return;
		
		$author = JFactory::getUser($row->user_id);
		if ( $params->get('name_type') == "name") $display_name = $author->name; else $display_name = $author->username;
		if ($params->get('is_new') == 1)
			$send_alert = true; 
		else 
		{
			$db = &JFactory::getDBO();
			$sql = "SELECT id FROM #__js_res_record_values WHERE field_id={$id} AND record_id={$row->id} LIMIT 1";
			$sql = $db->setQuery($sql);
			if ($db->loadObjectList()) $send_alert = false; else $send_alert = true;
		}
		
		
		if ($send_alert == true)
		{
			$reciver = JFactory::getUser($value);
			$mail_subject=JText::_($params->get('nu_mail_subject'));
			$body = JText::_($params->get('nu_mail_body')); //[CREATOR] has added new record for your consideration: [RECORDLINK] 
					
			$link = MEUrl::link_record($row, JRequest::getInt('category_id'));
			$record_link = JHTML::link(JURI::root().preg_replace("#^/#", '', MERoute::_($link)), $row->title);
			
			$body = str_replace('[CREATOR]', 		str_replace("\n"," ",$display_name), 	$body);
			$body = str_replace('[RECORDLINK]',  	$record_link, 							$body);
			
			$config = JFactory::getConfig();
			$_from = $config->getValue('config.mailfrom');
			$_name = $config->getValue('config.fromname');
			$mail = JFactory::getMailer();
			$sender[0] = $_from;
			$sender[1] = $_name;
			$mail->AddAddress($reciver->email);
			$mail->setSender($sender);
			$mail->addReplyTo($reply);
			$mail->isHTML(false);
			$mail->setBody(JMailHelper::cleanBody($body));
			$mail->setSubject(JMailHelper::cleanSubject($mail_subject));
			if (! $mail->Send())
			{
				JError::raiseWarning(400, JText::_('Error: Mail not sent.'));
				return false;
			}
		}
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;

		if($type != 'notifyuser') return;
		if(!$field->field_value) return;
		$user = JFactory::getUser($field->field_value);
		
		if ( $params->get('name_type') == "name") $display_name = $user->name; else $display_name = $user->username;
		
		switch( $params->get('user_name_linkage') ) {
			case 'none':
				$out = $display_name;
				break;	
			case 'user_profile':
				if( is_dir( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_community') ) {
					$profile_link = JRoute::_("index.php?option=com_community&controller=profile&user_id={$user->id}&Itemid=".JRequest::getInt('Itemid'));
					$out = JHTML::link( $profile_link, $display_name );
				} else if( is_dir( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_comprofiler') ) {
					$profile_link = JRoute::_("index.php?option=com_comprofiler&task=userProfile&user={$user->id}&Itemid=".JRequest::getInt('Itemid'));
					$out = JHTML::link( $profile_link, $display_name);
				}
				break;
			case 'popup':
				$out = JSCommunityApi::getUserSlideMenu($user->id, $display_name);
				break;
			default: $out = $display_name; break;
		}
	}

}