<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsText extends JPlugin
{
	function plgJoomsuite_content_fieldsText( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	function onJip($out, $type)
	{
		if($type != 'text') return;
		$out = true;
	}
	function onFilter($out, $type)
	{
		if($type != 'text') return;
		$out = true;
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'text') return;
		$unique_name =  $obj->id;
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];

		$pregmatch = $params->get('pregmatch', '');

		switch( $pregmatch ){
			// only numbers
			case 'num' :
				?>
<SCRIPT type="text/javascript">
				function pregmatch_<?php echo $unique_name ?>()
				{
					var currField = document.getElementById( 'fields<?php echo $obj->id; ?>').value;
					var regExp =  /[^0-9]+/;
					currField = currField.replace( regExp, '');					
					document.getElementById('fields<?php echo $obj->id ?>').value = currField;  							
				}									
			</SCRIPT>
				<?php
				break;
case 'text':
	?>
<SCRIPT type="text/javascript">
				function pregmatch_<?php echo $unique_name ?>()
				{
					var currField = document.getElementById( 'fields<?php echo $obj->id; ?>').value;
					var regExp =  /[^a-zA-Z\W!\@_]+/;
					currField = currField.replace( regExp, '');					
					document.getElementById('fields<?php echo $obj->id ?>').value = currField;  							
				}									
			</SCRIPT>
	<?php
	break;
case 'float':
	?>
<SCRIPT type="text/javascript">
				function pregmatch_<?php echo $unique_name ?>()
				{
					var currField = document.getElementById( 'fields<?php echo $obj->id; ?>').value;
					var reg1 = /[^0-9]+/;					
					var arrayTokens = currField.split( '.', 2 );					
					
					var part1 = '';										
					if( arrayTokens[ 0 ] ){
						part1 = arrayTokens[ 0 ];
						part1 = part1.replace(reg1, '');
					}
										
					var part2 = '';
					if( arrayTokens[ 1 ] ){				
						part2 = arrayTokens[ 1 ];
						part2 = part2.replace(reg1, '');
					}					
					
					var result = '';
					if( arrayTokens[ 0 ] && arrayTokens[ 1 ] )
						result = part1 + '.' + part2;					
					else if( arrayTokens[0] && !arrayTokens[ 1 ]){
						result = part1;
						if( currField.charAt( currField.length - 1 ) == '.' )
							result += '.'; 
					}else if( arrayTokens[1] ){
						result = part2;
					}
					
					document.getElementById('fields<?php echo $obj->id; ?>').value = result;									    				    
				} 
			</SCRIPT>
	<?php
	break;
case 'custom':
	$out = $params->get('custom_cs');
	?>
<SCRIPT type="text/javascript">
				function pregmatch_<?php echo $unique_name ?>()
				{				
					<?php
						$pattern  = "/\[id\]/i"; 
						$out = preg_replace($pattern, $obj->id, $out);
						echo $out;				 
					?>
				}
			</SCRIPT>
					<?php
					break;
			case 'registration':
				if ( $obj->field_value == '') $obj->field_value = $this->fetchField($obj, $params);
				//echo '<pre>'; var_dump ($user_data); echo '</pre>'; die;
			break;
case '0': break;
default:
	?>
<SCRIPT type="text/javascript">	function pregmatch_<?php echo $unique_name ?>(){} </SCRIPT>
	<?php
	break;
}
		echo "<span>".JText::_($params->get('sign_before'))."</span>";
		if ($pregmatch && $pregmatch != 'registration') $pregmatch = "onkeyup='pregmatch_$unique_name()'";
		?>			
			<input type="text" <?php echo $pregmatch ?> id="fields<?php echo $obj->id?>" <?php echo ((int)$params->get('maxlen')) ? 'maxlength="'. (int)$params->get('maxlen') .'"' : ''; ?> style="width:<?php echo $params->get('field_size')?>" name="fields[<?php echo $obj->id?>]" value="<?php echo htmlspecialchars(stripslashes($obj->field_value), ENT_QUOTES, 'UTF-8'  ); ?>" />
		<?php
		echo "<span>".JText::_($params->get('sign_after'))."</span>";
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'text') return;
		if(!$value) return;

		$pregmatch = $params->get('pregmatch');
		$pattern = '';
		switch( $pregmatch ){
			case 'num':
				$pattern = "/[^0-9]/i";
				$value =  preg_replace($pattern, '', $value);
				break;
			case 'text':
				$pattern = "/[^a-zA-Z\W!\@_]+/i";
				$value =  preg_replace($pattern, '', $value);
				break;
			case 'float':
				$parts = explode('.', $value, 2);
				$part1 = $parts[ 0 ];

				if( $part1 == '' || !$part1 ) $part1 = "0";

				$pattern = "/[^0-9]/i";
				$part1 = preg_replace($pattern, '', $part1);

				$part2 = ( @$parts[1] ) ? $parts[1] : '';
				if( $part2 != '' ){
					$part2 = preg_replace($pattern, '', $part2);
				}
				settype($part1, "string");
				settype($part2, "string");
				$result = $part1;
				$result .= ( $part2 ) ? ".".$part2 : '';
				$value = $result;
				break;
			case 'custom':
				$out = $params->get('custom_ss');
				eval( $out );
				break;
					
		}


		$db = &JFactory::getDBO();
		$value = $db->getEscaped( trim($value) );

		#echo $value;
		#die;
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		
		if($type != 'text') return;
		if( !$field->field_value ) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$all = $field->field_value;

		if (JRequest::getCmd('view') != 'article' && $params->get('length', 0)) {
			jimport ('joomla.utilities.string');
			$len = $params->get('length', 0);
			if ($len && JString::strlen($field->field_value) > $len) {
				if ($params->get('allow_html')) {
					require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'html'.DS.'html_stripper.php';

					$field->field_value = JSHTMLStripper::substr($field->field_value, $len, $params->get('seemore', ''));
				}
				else {
					$field->field_value = $field->field_value." ";
					$field->field_value = JString::substr($field->field_value, 0, $len);
					$field->field_value = JString::substr($field->field_value, 0, JString::strrpos($field->field_value,' '));
					$field->field_value = $field->field_value." ".$params->get('seemore', '');
				}
			}
		}

		$field->field_value = stripslashes( $field->field_value );

		if ( !$params->get('allow_html', 1) )
		$field->field_value = htmlspecialchars($field->field_value, ENT_QUOTES, 'UTF-8');
		
		$params->set('category_id', $category);
		$field->field_value = ResHelper::cleanFilterValue($field->field_value, base64_encode($all), $field, $params, $record);

		$out = trim(stripslashes( JText::_($params->get('sign_before'))." ".$field->field_value." ".JText::_($params->get('sign_after'))));
		wordSensor($out);
	}
	
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		//$sql = false;
		if( $type->type != 'text' ) return;
		if( !$value ) return;
		
		$sql = "field_value = '{$value}'";
	}
	//function onRenderFilter($get, &$filter, $fparam, $filters_type /*, $user*/)
	function onRenderFilter(&$get, &$filter, &$params, $category)
	{
		global $mainframe, $option;
		static $results = array();

		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;
		
		if($filters_type != 'text') return;
		
		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$db = & JFactory::getDBO();
		
		$where = getFilterWhere($params);
			
		switch ($params->get('filters_mode', 1))
		{
			case 1:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid = {$category} {$where}
				GROUP BY fv.field_value";
				break;
			case 3:
				$category = JRequest::getInt('category_id', $category);
				$ids = ResHelper::getCategoryChildrenIds($category);
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid IN ({$ids}) {$where}
				GROUP BY fv.field_value";
				break;
				
			case 2:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				WHERE fv.field_id = {$filter->id} {$where}
				GROUP BY fv.field_value";
				break;
		}

		if($fparam->get('order_by')) $sql .= ' ORDER BY ' . $fparam->get('order_by');

		//echo $sql;
		if(!key_exists($sql, $results))
		{
			$db->setQuery($sql);
			$get = $db->loadObjectList();
			$results[$sql] = $get;
		}
		else
		{
			$get = $results[$sql];
		}

		if(is_array($get))
		{
			foreach ($get AS $key => $val)
			{
				$get[$key] = JHTML::_('select.option', base64_encode($val->value), $val->text);
			}
		}
	}
	
	function fetchField(&$obj, &$params) 
	{
		$field_title = strtolower($params->get('userdata', ''));
		$user = & JFactory::getUser();
		if ($this->pingJUser() && $user->get('id')) 
		{
			// Get the user's core data
			$default = array('username', 'name', 'email');
			
			if ( in_array($field_title, $default) )
			{
				$fvalue = $user->get($field_title, '');
			}
			else
			{
				$db = & JFactory::getDBO();
				$q = 'SELECT d.fvalue FROM `#__juser_extended_data` d '.
				'LEFT JOIN #__juser_extended_fields f ON f.id = d.field_id '.
				'WHERE d.user_id = '.(int)$user->get('id').' AND d.field_id = '.(int)$params->get('userdata', '');
				$db->setQuery( $q );
				$fvalue = $db->loadResult();
			}
		}
			
		return $fvalue;
	}
	
	function pingJUser() {
		return JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'juser.php');
	}
}
?>