<?php
/**
 * @fileID: $Id: url_plus.php 7553 2011-11-29 07:12:43Z kostya $
 * @changedDate: $LastChangedDate: 2011-11-29 14:12:43 +0700 (Вт, 29 ноя 2011) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsUrl_plus extends JPlugin
{
	function plgJoomsuite_content_fieldsUrl_plus( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'url_plus') return;
		for ($i=1; $i<=4; $i++){
			$vars_par[$i] = $params->get("var$i");
			$seps[$i] = $params->get("sep$i");
			$edts[$i] = $params->get("var{$i}_edit");
		}
		$url = $params->get("url");
		$url_edt = $params->get("url_edit");
		$value = $obj->field_value;
		if ($value){
			$value = str_replace ('http://', '', $value);
			$reg = str_replace ($seps, '|', $value);
			$vars_val = explode("|", $reg);
			$url = $vars_val[0];
		}			
		for ($i=1; $i<=4; $i++){
			if (isset($vars_val[$i])) $vars[$i] = $vars_val[$i];
			else $vars[$i] = $vars_par[$i];							
		}
		$mode = $params->get('mode');
		if ($mode == 3){
				if ($url_edt == 1)
					echo '<input type="text" name="fields['.$obj->id.'][url]" id="fields['.$obj->id.'][url]" size="30" value="'.$url.'" />';
				else 
					echo 'http://'.$url;
			for ($i=1; $i<=4; $i++){
				if ($edts[$i] == 1){
					echo $seps[$i].'<input type="text" name="fields['.$obj->id.'][]" id="fields['.$obj->id.']['.$i.']"size="30" value="'.$vars[$i].'" />';
				}else{ 
					if (isset($vars[$i])){
						echo $seps[$i].$vars[$i].'<input type="hidden" readonly="readonly" name="fields['.$obj->id.'][]" id="fields['.$obj->id.'][]" value="'.$vars[$i].'" />';
					}
				}
			}			
		}
		else {
			if ($url_edt == 1){
				echo JText::_("URL");
				echo '<input type="text" class="inputbox" name="fields['.$obj->id.'][url]" id="fields['.$obj->id.'][url]" size="30" value="'.$url.'" /><br />';
			}else{
				echo JText::_("URL");
				echo ' http://'.$url.'<br />';
			}
			
			for ($i=1; $i<=4; $i++){
				if($mode != 2){
					echo JText::_("Var$i").': ';
				}
				if ($edts[$i] == 1){
					echo '<input type="text" class="inputbox" name="fields['.$obj->id.'][]" id="fields['.$obj->id.'][]" value="'.$vars[$i].'" /><br />';
				}else{
					echo $vars[$i].'<br /><input type="hidden" readonly="readonly" name="fields['.$obj->id.'][]" id="fields['.$obj->id.'][]" value="'.$vars[$i].'" />';
				}
			}
		}
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{

		if($type != 'url_plus') return;
		if(!$value) return;

		for ($i=1; $i<=4; $i++){
			$vars_par[] = $params->get("var$i");
			$seps[] = $params->get("sep$i");
			$edts[] = $params->get("var{$i}_edit");
		}
		if (isset($value['url']) && $params->get("url_edit")==1){
			$url = $value['url'];
		}
		else $url = $params->get("url");
		$url = str_replace('http://', '', $url);		
		for ($i=0; $i<=3; $i++){
			if ($value[$i] && $edts[$i] == 1){
				$vars[] = $value[$i];
			}
			else if ($vars_par[$i]){
				$vars[] = $vars_par[$i];
			}
			else{
				continue;
			}
		}
		$link = null;
		foreach($vars as $key=>$var){
			$link .= $seps[$key].$var;
		}
		if ($link)
		$value = 'http://'.$url.$link;
		else
		$value = 'http://'.$url;
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
	
		if(!$field->field_value) return;

		if($type != 'url_plus') return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$url = $field->field_value;
		if($params->get('title')) 
			$title = $params->get('title'); else $title =  str_replace('http://', '', $url);
		
		if($params->get('direct')) 
			$link = $url;
		else
			$link = JRoute::_('index.php?option=com_resource&task=g&link='.$field->id);

		$atr['title'] = str_replace('http://', '', $url);
		if ($params->get('target') == 'shbox')
		{
			$document = &JFactory::getDocument();
			static $ini = false;
			$basedomain = JURI::root();
			if ($ini == false){
				$document->addScript($basedomain."media/mightyextensions/js/shadowbox/build/adapter/shadowbox-base.js");
				$document->addScript($basedomain."media/mightyextensions/js/shadowbox/build/shadowbox.js");
				$document->addScriptDeclaration("
						Shadowbox.loadSkin('classic', '".$basedomain."media/mightyextensions/js/shadowbox/build/skin');
						Shadowbox.loadLanguage('en', '".$basedomain."media/mightyextensions/js/shadowbox/build/lang');
						Shadowbox.loadPlayer(['iframe'], '".$basedomain."media/mightyextensions/js/shadowbox/build/player');
						window.onload = function(){
							Shadowbox.init();
						}");
				$ini = true;
			}
			$atr['rel'] = 'shadowbox';
		}else{
			$atr['target'] = $params->get( 'target', '_blank' );
		}
		

		$out = JHTML::link($link, $title, $atr);
		if($params->get('show_hits') && !$params->get('direct') )	{
			$db = & Jfactory::getDBO();
			$sql = "SELECT count(*) FROM #__js_res_download_hits WHERE item_id = {$field->id}";
			$db->setQuery($sql);
			$num = (int)$db->loadResult();
			$out .= " (".JText::_('Views').": {$num})";
		}
	}
}
?>