<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsVideo extends JPlugin
{
    function plgJoomsuite_content_fieldsVideo( &$subject, $params )
    {
        parent::__construct( $subject, $params );
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'jsfilemanager.php';
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
    }

    function onRenderField(&$obj, &$params, $type)
    {
        if($type != 'video') return;

        $def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];

        $video = 'swf, avi, wmv, mpeg, mov';
        switch($params->get('type'))
        {
            case 1:
                ?>
<input type="file" style="width:<?php echo $params->get('field_size')?>"  name="files[<?php echo $obj->id ?>]" />
                <?php
                break;

            case 2:
                echo '<input type="text" tyle="width:'.$params->get('field_size').'" name="fields['.$obj->id.']" value="'.$obj->field_value.'" />';
                if($params->get('type') == 3) echo '<br>'.JText::_('Type path based from Joomla installation root');
                if($params->get('type') == 2) echo '<br>'.JText::_('Type URL including http://');
                break;
            case 3:
                $filter =  explode(", ", $video); //print_r(explode(", ", $video));
                ?>
<select  style="width:<?php echo $params->get('field_size')?>" name="fields[<?php echo $obj->id; ?>]" class="inputbox" size="1">
                    <?php echo implode("\n", ResViewRecord::files($params->get('directory'), $params, $obj->field_value, $filter));?>
</select>
                <?php
                break;
        }
        if($obj->field_value && ($params->get('type') == 1) )
        {
            echo '<br><input type="checkbox" value="1" name="remove['.$obj->id.']" value="'.$obj->field_value.'" />'.JText::_('Remove Current');
            echo " ({$obj->field_value})";
            echo "<input type=\"hidden\" name=\"fields[{$obj->id}]\" value=\"{$obj->field_value}\" />";
        }
        echo '<br>'.JText::_('Allowed formats are ').": ".${$obj->type}."</span>";

        $authorId = 0;
        if ($obj->record_id)
        {
            JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'tables');
            $record = & JTable::getInstance('record','Res');
            $record->id = $obj->record_id;
            $record->load();
            $authorId = (int)$record->user_id;
        }

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
        $fileHelper = & JS_File_Helper::getInstance();

        $authorId = $fileHelper->getRecordOwner($obj->record_id);
        echo '<input type="hidden" name="fields[author][', $obj->id, ']" value="', $authorId, '"/>';
    }

    function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
    {
        if($type != 'video') return;

        $db = &JFactory::getDBO();
        $value = $db->getEscaped($value);

        jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        $post  = JRequest::get('POST');
        $files = JRequest::get('FILES');

        if(!empty($post['remove'][$id]))
        {
            JFile::delete(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.'video'.DS.$value);
            $value = '';
        }


        if (!empty($files['files']['name'][$id]))
        {
            $tmp_name   = $files['files']['tmp_name'][$id];
            $name	= JFile::makeSafe($files['files']['name'][$id]);
            $size	= $files['files']['size'][$id];
            $value 	= $db->getEscaped($name);
            $ext 	= strtolower(substr($name, strrpos($name, '.') + 1));
            $exts 	= array('swf', 'avi', 'wmv', 'mpeg', 'mpg', 'mov');

            $folder = JPath::clean(RES_GENERAL_UPLOAD.DS.(int)$row->user_id.DS.'video');

            if(!JFolder::exists($folder))
            {
                if(!JFolder::create($folder, 0755))
                {
                    $message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');

                    JError::raiseError(403, $message);
                    $error = 1;
                    return;
                }
            }
            if(!in_array($ext, $exts))
            {
                $msg = JText::_("File is not apropriate format");
                $msg .= "<br>File: ".basename($name);
                $msg .= "<br>Allowed Formats: ".implode(", ", $exts);
                JError::raiseWarning(403, $msg);
                $error = 1;
                return;
            }

            $maxFileSize = $params->get ( 'max' ) * 1024;

            if (($size > $maxFileSize) && $maxFileSize)
            {
                $msg = JText::_ ( "File size exceed allowed" );
                $msg .= "<br>File: " . $name;
                $msg .= "<br>Size: " . number_format ( $size, 0, '', ',' );
                $msg .= "<br>Allowed Size: " . number_format ( $maxFileSize, 0, '', ',' );
                JError::raiseWarning ( 403, $msg );

                $error = 1;

                return false;
            }

            if($params->get('attach')) $name = time().'_'.$name;

            $value = $db->getEscaped($name);

            $dest = $folder.DS.$name;

            if(JFile::exists($dest) && !$params->get('overwrite'))
            {
                $msg = JText::_("This File already Exists");
                $msg .= "<br>File: ".$name;
                JError::raiseWarning(403, $msg);
                $error = 1;
                return;
            }
            if(!JFile::upload($tmp_name, $dest))
            {
                $msg = JText::_("Could not upload the file");
                $msg .= "<br>File: ".$name;
                JError::raiseError(403, $msg);
                $error = 1;
                return;
            }

            @chmod($dest, 0644);
        }
        else
        {
            $author = (isset($_REQUEST['fields']['author'][ $id ]) ? (int)$_REQUEST['fields']['author'][ $id ] : -1);

            if ($author >= 0 && $row->user_id != $author)
            {
                $baseDir = JPath::clean(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.'video');
                if (!JFolder::exists($baseDir))
                    JFolder::create($baseDir, 0755);

                $oldFile = JPath::clean(RES_GENERAL_UPLOAD.DS.$author.DS.'video'.DS.$value);
                if (JFile::exists($oldFile))
                {
                    JFile::move($oldFile, $baseDir.DS.$value);
                    @chmod($baseDir.DS.$value, 0644);
                }
            }
        }
    }

    function onArticleAuthorChange(&$records, $newAuthor)
    {
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';

        $fileHelper = JS_File_Helper::getInstance();
        $fileHelper->reassignFilesOld($records, $newAuthor, 'video');
    }

    /**
     * Delete the uploaded files
     * @param $recordIds
     * @return unknown_type
     */
    function onDeleteRecords($recordIds)
    {
        jimport ('joomla.filesystem.file');

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        $db = & JFactory::getDBO();

        $q = 'SELECT r.id AS record_id, r.user_id, rv.field_value, f.params FROM '.
                '#__js_res_record r '.
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                'WHERE '.
                'r.id IN ('.implode(',', $recordIds).') AND f.type = "video"';

        $db->setQuery( $q );
        $recs = $db->loadObjectList();

        foreach ($recs as $rec)
        {
            if (empty($rec->user_id) || empty($rec->field_value))
                continue;

            $params = new JParameter($rec->params);
            if ($params->get('type') == 1)
            {
                $file = JPath::clean(RES_GENERAL_UPLOAD .DS .$rec->user_id .DS.'video'. DS .JFile::makeSafe($rec->field_value));
                $fileHelper = JS_File_Helper::getInstance();
                $fileHelper->removeFiles($file);
            }
        }
    }

    function onRenderFieldValue(&$out, &$field, &$record, $category)
    {
        $type = $field->type;

        if(!$field->field_value) return;

        if($type != 'video') return;

        $params = new JParameter($field->params);
        $user = $record->user_id;

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        switch ($params->get('type'))
        {
            case 1:
                $file = JPath::clean(RES_GENERAL_UPLOAD.DS.$user.DS.'video'.DS.$field->field_value);
                break;
            case 3:
            case 2:
                $file = JPath::clean( JPATH_ROOT.DS.$field->field_value );
                break;
        }

        if($params->get('type') == 1 || $params->get('type') == 3)
        {
            //$source = JURI::root()."index2.php?option=com_resource&task=show_video&no_html=1&video=$field->id";
            $fileManager = &JSFileManager::getInstance();
            $source = JURI::root().$fileManager->getDownloadUrl($field->id);
        }
        if($params->get('type') == 2)
        {
            $source = $field->field_value;
        }

        $ext = strtolower(substr($field->field_value, strrpos($field->field_value, '.')+1));
        $quality = $params->get('quality');
        $bg = $params->get('backgroung');

        $width = $params->get('width');
        $height = $params->get('height');

        $embede="";
        switch ($ext)
        {
            case "swf":
                $embede = "
			<object classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\""
                        .(isset($width) ? " width=\"$width\" " : NULL)
                        .(isset($height) ? " height=\"$height\" " : NULL)
                        ."><param name=\"movie\" value=\"$source\" />
			<param name=\"quality\" value=\"$quality\" /> 
			<param name=\"bgcolor\" value=\"$bg\" /> 
			<embed src=\"$source\" quality=\"$quality\" bgcolor=\"$bg\""
                        .(isset($width) ? " width=\"$width\" " : NULL)
                        .(isset($height) ? " height=\"$height\" " : NULL)
                        ."name=\"movie$field->id\" align=\"\" type=\"application/x-shockwave-flash\"
			pluginspage=\"http://www.macromedia.com/go/getflashplayer\"> 
			</embed> 
			</object>";
                break;

            case "avi":
            case "wmv":
                $embede = "  
				<OBJECT id=\"movie$field->id\" width=\"$width\" height=\"$height\" 
					CLASSID=\"CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6\" type=\"application/x-oleobject\">
					<PARAM NAME=\"URL\" VALUE=\"$source\">
					<PARAM NAME=\"SendPlayStateChangeEvents\" VALUE=\"True\">
					<PARAM NAME=\"AutoStart\" VALUE=\"False\">
					<PARAM name=\"uiMode\" value=\"mini\">
					<PARAM name=\"PlayCount\" value=\"1\">
					<embed width=\"$width\" height=\"$height\" type=\"application/x-mplayer2\" src=\"$source\" AutoStart=\"False\" PlayCount=\"1\" uiMode=\"mini\"></embed>
				</OBJECT>
                        ";
                break;
            case "mpeg":
            case "mpg":

                $embede ="
				<object CLASSID=\"CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95\" 
					codebase=\"http://activex.microsoft.com/activex/controls/mplayer/en/nsm p2inf.cab#Version=5,1,52,701\"
					standby=\"Loading Microsoft Windows Media Player components...\" 
					type=\"application/x-oleobject\" width=\"$width\" height=\"$height\">
					<param name=\"fileName\" value=\"$source\">
					<param name=\"animationatStart\" value=\"true\">
					<param name=\"transparentatStart\" value=\"true\">
					<param name=\"AutoStart\" value=\"false\">
					<param name=\"showControls\" value=\"true\">
					<embed id=\"movie$field->id\" type=\"application/x-mplayer2\" 
					pluginspage=\"http://www.microsoft.com/Windows/MediaPlayer/\" 
					src=\"$source\" name=\"MediaPlayer1\" width=$width height=$height autostart=0 showcontrols=1>
					</object>
                        ";

                break;
            case "mov":
                $embede ="<object width=\"$width\" height=\"$height\"  id=\"movie$field->id\"
					 classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" 
					 codebase=\"http://www.apple.com/qtactivex/qtplugin.cab\">
					<param name=\"src\" value=\"$source\">
					<param name=\"controller\" value=\"true\">
					<param name=\"autoplay\" value=\"false\">
					<!-- Code For Older Browsers -->
					<embed src=\"$source\" width=\"$width\" height=\"$height\"
					 autoplay=\"false\"
					 controller=\"true\"
					 pluginspage=\"http://www.apple.com/quicktime/download/\">
					</embed>
					</object>
                        ";
                break;
        }

        $out = $embede;
    }

    function onDownloadFile($field, $recordValue)
    {
        if($field->type != 'video')
        {
            return;
        }
        $file = $recordValue->field_value;
        $pathData = new stdClass();
        $fileHelper = &JS_File_Helper::getInstance();
        $user = &JFactory::getUser();
        //$params = new JParameter($field->params);
        if($fileHelper->checkSubscription($field->params))
        {
           $pathData->path = RES_GENERAL_UPLOAD.DS.$field->user_id.DS.'video'.DS.$file;
           $fileHelper->modifyUsersCarma($field->params, $field->user_id, $user->get('id'));
        }
        $pathData->error = null;
        return $pathData;

    }
}