<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsCalendar extends JPlugin
{
	function plgJoomsuite_content_fieldsCalendar( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'calendar') return;
		
		$def = JRequest::getVar('fields', null, 'default', 'array');
		if($def[$obj->id]) $obj->field_value = $def[$obj->id];
		
		if (empty($obj->field_value))
		{
			$obj->field_valu = ResHelper::getDate();
			//$now->setOffset($config->getValue('config.offset'));
			//$obj->field_value = $now->toFormat('%Y-%m-%d %H:%M:%S');
		} 
		
		echo JHTML::_('calendar', $obj->field_value, "fields[$obj->id]", 'calendar_'.$obj->id, '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));
		?>
		<script>
			window.addEvent('domready', function() {
				function validateCal(el) {
					//if (el.value.match(/^\d{4}-(?:(?:0[0-9])|(?:1[0-2]))-(?:(?:[0-2][0-9])|(?:3[01]))\s+[0-2]?[0-9]:[0-6]?[0-9]:[0-6]?[0-9]$/))
					if (el.value.match(/^(((\d{4})(-)(0[13578]|10|12)(-)(0[1-9]|[12][0-9]|3[01]))|((\d{4})(-)(0[469]|11)(-)([0][1-9]|[12][0-9]|30))|((\d{4})(-)(02)(-)(0[1-9]|1[0-9]|2[0-8]))|(([02468][048]00)(-)(02)(-)(29))|(([13579][26]00)(-)(02)(-)(29))|(([0-9][0-9][0][48])(-)(02)(-)(29))|(([0-9][0-9][2468][048])(-)(02)(-)(29))|(([0-9][0-9][13579][26])(-)(02)(-)(29)))(\s([0-1][0-9]|2[0-4]):([0-5][0-9]):([0-5][0-9]))$/))
						return false;
					alert('<?php echo JText::_($params->get('error_validation_message', 'Wrong date, please choose from calendar'), true); ?>');
					el.value = '';
				}
				
				$('calendar_<?php echo $obj->id; ?>').addEvent('blur', function() {
					return validateCal($('calendar_<?php echo $obj->id; ?>'));
				});
			});
		</script>
		<?php 
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'calendar') return;
		
		$db = &JFactory::getDBO();
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'calendar') return;
		if(!$field->field_value) return;
		
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		
		if(JRequest::getString('option') != 'com_resourse')
		jimport('joomla.utilities.date');
		$params = new JParameter($field->params);
		$date = JFactory::getDate($field->field_value);
		//$date->setOffset($config->getValue('config.offset'));
		$out = $date->toFormat($params->get('custom', $params->get('format')));
	}
}