<?php
/**
 * BB code parser
 * @author Nurlan
 *
 */
class JS_BBCodeParser {
	function bb2html($text)
	{
	  	$bbcode = array("<", ">",
	                "[list]", "[*]", "[/list]", 
	                "[img]", "[/img]", 
	                "[b]", "[/b]", 
	                "[u]", "[/u]", 
	                "[i]", "[/i]",
	                '[color="', "[/color]",
	                "[size=\"", "[/size]",
	                "[mail=\"", "[/mail]",
	                "[code]", "[/code]",
	                "[quote]", "[/quote]",
	                '"]');
	 	$htmlcode = array("&lt;", "&gt;",
	                "<ul>", "<li>", "</ul>", 
	                "<img src=\"", "\">", 
	                "<b>", "</b>", 
	                "<u>", "</u>", 
	                "<i>", "</i>",
	                "<span style=\"color:", "</span>",
	                "<font size=\"", "</font>",
	                "<a href=\"mailto:", "</a>",
	                "<code>", "</code>",
	                "<pre>", "</pre>",
	                '">');
	 	
		$newtext = str_replace($bbcode, $htmlcode, $text);
		
		$regExp = array(
			'/(?:\[url=)([^\]]+)\]([^\[]+)\[\/url\]/',
			'/(?:\[url\])([^\[]+)\[\/url\]/'
		);

		$replace = array(
			'<a href="\1">\2</a>',
			'<a href="\1">\1</a>'
		);
		
		$newtext = preg_replace($regExp, $replace, $newtext);
		
		$newtext = nl2br($newtext);//second pass
		
	  	return $newtext;
	}
}
?>
