<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsMail extends JPlugin
{
	function plgJoomsuite_content_fieldsMail( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'mail') return;
		
		$access = $params->get('access', 0);
		$user = JFactory::getUser();
		
	/*	if (!JRequest::getInt('article'))
			$value = 1;
		else
	*/		$value = $obj->field_value;
	
		if( $user->aid >= $access){
			$o = '';
			$o[] = JHTML::_('select.option', '1', JText::_('Yes'));
			$o[] = JHTML::_('select.option', '0', JText::_('No'));
			echo JHTML::_('select.genericlist', $o, "fields[$obj->id]", '', 'value', 'text', (int)$value);
		}
		else
			echo '<input type="hidden" name="fields['.$obj->id.']" value="'.$value.'">';
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{	
		if($type != 'mail') return;
		
		if(!$value) return;
		$db = &JFactory::getDBO();		
		if( $params->get('user_subject') == 2 ){		
			$pre_subject_values = explode("\n", trim($params->get('pre_subject_val')));
			// only predefined values
			if( !in_array($value, $pre_subject_values) ) return;
		}
		
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(!$field->field_value) return;

		if($field->type != 'mail') return;
		
		$params = new JParameter($field->params);
		
	    if( JRequest::getVar('task', false) == '__sendMail' && $field->id == JRequest::getVar('mail', false)) {
			JRequest::setVar('task', false);
			$this->_mail( $params, $field, $record );
		}
		
		$user = $record->user_id;
		$type = $field->type;
		
		global $mainframe, $option;

		$uri  		= &JFactory::getURI();
		$user 		= &JFactory::getUser($user);
		$me 		= &JFactory::getUser();
		$document 	= &JFactory::getDocument();
		$db 		= &JFactory::getDBO();
		
		$uid		= uniqid('mail');
		$url		= $uri->toString();

		// need moo here %)
		JHTML::_('behavior.mootools');
		
		if ($params->get('highslide'))
		{
			$document->addStyleSheet(JURI::root()."plugins/joomsuite_content_fields/mail.css");
			
			$document->addScript(JURI::root()."media/mightyextensions/js/shadowbox/build/adapter/shadowbox-base.js");
			$document->addScript(JURI::root()."media/mightyextensions/js/shadowbox/build/shadowbox.js");
			
			$width 	= $params->get('shadowbox_width', 700);
			$height = $params->get('shadowbox_height', 600);
						
			$out[] = "<script type='text/javascript'>
				Shadowbox.loadSkin('".$params->get('shadowbox_skin', 'classic')."', '".JURI::root()."media/mightyextensions/js/shadowbox/build/skin');
				Shadowbox.loadLanguage('en', '".JURI::root()."media/mightyextensions/js/shadowbox/build/lang');
				Shadowbox.loadPlayer(['html'], '".JURI::root() ."media/mightyextensions/js/shadowbox/build/player');
				
				window.addEvent('domready', function(){
				    Shadowbox.init({
						overlayColor: '#000000',
						counterType: 5,
						counterLimit: 10,
						handleOversize: 'resize',
						gallery: '".uniqid('mail_')."',
						player: ['html'],
						enableKeys: false
					});
					
					var mailElement = null;
					var mailElementParent = null;
					var formContainer = null;
					
					$('$uid').addEvent('click', function() 
					{
						// remove the element from dom.
						mailElement = $('mail-$uid');
						mailElementParent = mailElement.getParent();
						mailElement.remove();
						
						var form = new Element('form', {
							method: 'post',
							enctype: 'multipart/form-data'
						});
						
						form.setProperty('action', '$url');
						
						form.appendChild(mailElement);
						var formContainer = new Element('div');

						formContainer.appendChild(form);
						
						mailElement.setStyle('display', 'block');
						
						Shadowbox.open(
							{
								content: formContainer.innerHTML,
								player: 'html',
								width: {$width},
								height: {$height},
								title: '{$field->title}'
							},
							{
								onClose: function() {
									mailElement.setStyle('display', 'none');
									mailElementParent.appendChild(mailElement);
								}
							}
						);
					});
				});
			</script>";
			
			
			
			$out[] = '<a id="'.$uid.'" href="'.$url.'#mail-'.$uid.'" title="'.$field->title.'">'
				.JText::_($params->get('slide_label', $field->title)).'
				</a>';
			$out[] = '<div id="mail-'.$uid.'" style="display: none;">
						<div id="mail-'.$uid.'-content" class="ShadowboxFont">
					';
		}elseif (!JRequest::getInt('article') && !$params->get('highslide')){
			$out [] = "<script type='text/javascript'>
			window.addEvent('domready', function() {
				$('mailSubmit$uid').addEvent('click', function() 
				{
					var taskElement = $('adminForm').getElement('input[name=task]')
					if( taskElement ) {
						taskElement.value = '__sendMail';
					} else {
						var input = new Element('input');
						input.setProperty('type', 'hidden');
						input.setProperty('name', 'task');
						input.value = '__sendMail';
						
						document.forms.adminForm.appendChild(input);
					}
				});
			});
			</script>";
		}
		
		if($params->get('description'))
		{
			$out[] = "<p>".$params->get('description')."</p>";
		}
		$sql = "SELECT catid FROM #__js_res_record_category where record_id='".$field->record_id."'";
		$db->setQuery($sql);
		$catid = $db->loadResult();
		
		// We don't have the 'adminForm' in article layout
		if (JRequest::getInt('article') && !$params->get('highslide'))
		    $out[] = "<form method=\"post\" enctype=\"multipart/form-data\">";
		
		$out[] = "<div id=\"mailform-$uid\">";
		$out[] = "<table border=0 cellpadding=5 cellspacing=0 width=\"100%\">";

		switch ($params->get('to')) {
			case 1:
				$out[] = sprintf('<tr><td width="150" >%s:</td><td>%s</td></tr>',
				JText::_('Send To'), JText::_('This record contact email'));
				break;
			case 2:
				$out[] = sprintf('<tr><td width="150">%s:</td><td>%s%s</td></tr>',
					JText::_('Send To'), JText::_('Administrator'),
				$params->get('show_to') ? '('.$mainframe->getCfg('mailfrom').')' : '');
				break;
			case 3:
				$out[] = sprintf('<tr><td width="150">%s:</td><td>%s %s</td></tr>',
				JText::_('Send To'), $user->get('name'),
				$params->get('show_to') ? ' ('.$user->get('email').')' : '');
				break;
			case 4:
				$out[] = sprintf('<tr><td width="150">%s:</td><td><input type="text" name="email_to" value="%s" size="%d" /></td></tr>',
				JText::_('Send To'), JRequest::getVar('email_to'), $params->get('size', 40));
				break;
			case 5:
				$out[] = sprintf('<tr><td width="150">%s:</td><td>%s</td></tr>',
				JText::_('Send To'), $params->get('show_to') ? $params->get('custom'): JText::_('Email Hidden'));
				break;

			default:
				break;
		}

		if($params->get('show_name'))
		{
			if ($me->get('id')>0)
			{
				$out[] = sprintf('<tr><td>%s:</td><td>%s<input type="hidden" name="name_%d" '.
				' value="%s" /></td></tr>',
				JText::_('Your Name'), $me->name, $field->id,
				$me->name);
			}
			else
			{
				$out[] = sprintf('<tr><td>%s:</td><td><input type="text" style="%s;" name="name_%d" '.
				' value="%s" /></td></tr>',
				JText::_('Your Name'),'width:99%', $field->id,
				JRequest::getVar('name_'.$field->id, ''));

			}
		}
		else
		{
			$out[] = sprintf('<tr style="display: none;"><td></td><td><input type="hidden"  '.
			'name="name_%d" value="%s" /></td></tr>',
			$field->id,	$me->name);
		}
		
		if($params->get('show_email'))
		{
			if ($me->get('id')>0)
			{
				$out[] = sprintf('<tr><td >%s:</td><td>%s<input type="hidden"  '.
				'name="email_from_%d" value="%s" /></td></tr>',
				JText::_('Your Email'),  $me->email, $field->id,
				$me->email);

			}
			else
			{
				$out[] = sprintf('<tr><td >%s:</td><td><input type="text" style="%s;"  '.
				'name="email_from_%d" value="%s" /></td></tr>',
				JText::_('Your Email'),'width:99%', $field->id,
				JRequest::getVar('email_from_'.$field->id));
			}
		}
		else
		{
			$out[] = sprintf('<tr style="display: none;"><td></td><td><input type="hidden"  '.
			'name="email_from_%d" value="%s" /></td></tr>',
			$field->id,	$me->email);
		}
	    if($params->get('cc'))
		{
			$out[] = sprintf('<tr><td >%s:</td><td><input type="text" style="%s;"  '.
			'name="cc_%d" value="%s" /></td></tr>',
			JText::_('Cc'),'width:99%',  $field->id,
			JRequest::getVar('cc_'.$field->id));
		}
		if($params->get('user_subject', 0) == 1)
		{			
			$out[] = sprintf('<tr><td >%s:</td><td><input type="text" style="%s;"  '.
			'name="subject_%d" value="%s" /></td></tr>',
			JText::_('Subject'),'width:99%',  $field->id,
			JRequest::getVar('subject_'.$field->id));
		}else if( $params->get('user_subject', 0) == 2){
			$pre_subject_values = explode("\n", trim($params->get('pre_subject_val')));			
			if(count($pre_subject_values)){
				$select_list = "<select name='subject_".$field->id."' style='width: 99%;'>";
				foreach($pre_subject_values AS $value)
				{
					$selected = ($value == JRequest::getVar('subject_'.$field->id)) ? "selected='selected'" : "";
					$value = trim($value);
					$select_list .= "<option value='{$value}' {$selected}>{$value}</option>";
				}
				$select_list .= "</select>";
				$out[] = sprintf('<tr><td >%s:</td><td>%s</td></tr>',
				JText::_('Subject'), $select_list);
			}			
		}
		if($params->get('show_body'))
		{
			$out[] = sprintf('<tr valign="top"><td >%s:</td><td><textarea style="%s;"  '.
			'name="body_%d" rows="15">%s</textarea></td></tr>',
			JText::_('Message'), 'width:99%', $field->id,
			JRequest::getVar('body_'.$field->id));
		}
        if($params->get('show_add_fields'))
		{
		    $schema = $params->get('additional_fields');
		    $add_fields_values = JRequest::getVar('add_field', false);
		    
		    if($schema)
		    {
		        $add_fields = explode(';',trim($schema));
		        foreach ($add_fields as $f) {
		        	$field_info = explode(':',$f);
		        	
		        	if( count($field_info)>2 ){
		        	    switch( trim($field_info[0]) ) {//type
		        	        case 'text':
		        	            $out[] = '<tr><td >'.JText::_($field_info[2]).':</td><td>
	        	                <input type="'.trim($field_info[0]).'" 
	        	                	name="add_field['.trim($field_info[1]).']" 
	        	                	value="'.@trim($add_fields_values[$field_info[1]]).'" 
	        	                	style="width:99%" />
	        	                	</td></tr>';
		        	            break;
        	                case 'radio': 
        	                    $out[] = '<tr><td >'.JText::_($field_info[2]).':</td><td>';
	        	                if( isset($field_info[3]) ) {
    	        	                $values = explode('|',$field_info[3]);
    	        	                foreach ($values as $val) {
    	        	                	$out[] = '<input type="'.trim($field_info[0]).'" 
    	        	                	name="add_field['.trim($field_info[1]).']" '.@trim($field_info[4]).' 
    	        	                	value="'.trim($val).'" '.( (isset($add_fields_values[$field_info[1]]) && $add_fields_values[$field_info[1]] == $val )? 'checked ': '').'>'.$val;
    	        	                }
	        	                } else {
	        	                    $out[] = '<input type="'.trim($field_info[0]).'" 
    	        	                	name="add_field['.trim($field_info[1]).']" '.@trim($field_info[4]).' 
    	        	                	value="'.trim($field_info[1]).'" '.(isset($add_fields_values[$field_info[1]]) ? 'checked' : '').'>'.$field_info[1];
	        	                }
	        	                $out[] ='</td></tr>';
        	                    
        	                    break;
	        	            case 'checkbox':
	        	                $out[] = '<tr><td >'.JText::_($field_info[2]).':</td><td>';
	        	                if( isset($field_info[3]) ) {
    	        	                $values = explode('|',$field_info[3]);
    	        	                foreach ($values as $val) {
    	        	                	$out[] = '<input type="'.trim($field_info[0]).'" 
    	        	                	name="add_field['.trim($field_info[1]).'][]" '.@$field_info[4].' 
    	        	                	value="'.trim($val).'" '.( (isset($add_fields_values[$field_info[1]]) && in_array($val, $add_fields_values[$field_info[1]]))? 'checked ': '').'>'.$val;
    	        	                }
	        	                } else {
	        	                    $out[] = '<input type="'.trim($field_info[0]).'" 
    	        	                	name="add_field['.trim($field_info[1]).'][]" '.@$field_info[4].' 
    	        	                	value="'.trim($field_info[1]).'" '.(isset($add_fields_values[$field_info[1]]) ? 'checked' : '').'>'.$field_info[1];
	        	                }
	        	                $out[] ='</td></tr>';
	        	                break;
	        	            case 'select':
	        	                $out[] = '<tr><td >'.JText::_($field_info[2]).':</td><td>';
	        	                if( isset($field_info[3]) ) {
    	        	                $values = explode('|',$field_info[3]);
    	        	                $out[] = '<select name="add_field['.$field_info[1].'][]" '.@$field_info[4];
    	        	                foreach ($values as $val) {
    	        	                	$out[] = '<option '.( (isset($add_fields_values[$field_info[1]]) && in_array($val, $add_fields_values[$field_info[1]]))? 'selected=selected ': '').'>'.$val.'</option>';
    	        	                }
	        	                } else {
	        	                    $out[] = '<input type="'.trim($field_info[0]).'" 
    	        	                	name="add_field['.trim($field_info[1]).'][]" '.@$field_info[4].' 
    	        	                	value="'.trim($field_info[1]).'" '.(isset($add_fields_values[$field_info[1]]) ? 'checked' : '').'>'.$field_info[1];
	        	                }
	        	                $out[] ='</td></tr>';
	        	                break;
	        	            case 'textarea':
	        	                $out[] = '<tr><td >'.JText::_($field_info[2]).':</td><td>
	        	                <textarea name="add_field['.$field_info[1].']" style="width:99%">'.@$add_fields_values[$field_info[1]].'</textarea></td></tr>';
	        	                break;
		        	    }
		        	}
		        }
		    }
		}
		if($params->get('attachment'))
		{
			$out[] = sprintf('<tr valign="top"><td >%s:</td><td><input type="file" '.
			'name="attachment_%d" style="width:%s" /><br>%s: %s</td></tr>',
			JText::_('Attachment'),  $field->id, $params->get('size', '100%'),
			JText::_('Allowed Formats'), $params->get('formats'));
		}
		if($params->get('copy_to_sender', 1))
		{
			$out[] ='
			<tr valign="top">
					<td>'.JText::_('Send copy to sender').'</td>
					<td>
					<input type="radio" name="copy_to_sender_'.$field->id.'" value="0"> '.JText::_('No').'				
					<input type="radio" name="copy_to_sender_'.$field->id.'" value="1" checked> '.JText::_('Yes').'
					</td>
				</tr>'; 
		}
		
		if ($params->get('show_captcha',1))
		{
			if(!$params->get('captcha_type') || ($params->get('captcha_type') && $me->id < 1))
			{
				$out[]='
				<tr valign="top">
					<td>'.JText::_('Security code').'</td>
					<td>				
						<table>
							<tr valign="top">
								<td>
									<input id="captchabox'.$uid.'" style="width:65px;height:28px;border:2px solid black;font-size:22px" type="text" size="5" maxlength="5" name="mail_captcha_text" value="" />
								</td>
								<td>
									<img id="captcha'.$uid.'" align="absmiddle" src="'.JURI::root().'index.php?tmpl=component&option=com_resource&view=captcha&no_html=1&c=m'.$field->id.'&nocache='.uniqid('sddf').'" border="0" />
								</td>
							</tr>
						</table>
						<span class="small">'.JText::_('Enter text as you see on image').'</span>
					</td>
				</tr>';
			}
		}
		$out[] = sprintf('<tr><td></td><td><input type="submit" id="mailSubmit'.$uid.'" name="submit_%d" value="%s" class="button"/></td></tr>',
		$field->id, $params->get('button', JText::_('Send')));

	    $out[] = "</table>";
	    if (JRequest::getInt('article') || $params->get('highslide'))
		    $out[] = "<input type=\"hidden\" name=\"task\" value=\"__sendMail\">";
		$out[] = "<input type=\"hidden\" name=\"mail\" value=\"{$field->id}\">";
		$out[] = "<input type=\"hidden\" name=\"article_id\" value=\"{$field->record_id}\">";
		$out[] = "</div>";
		
		// close the form tag
		if (JRequest::getInt('article') && !$params->get('highslide'))
			$out[] = "</form>";
			
		if ($params->get('highslide'))
		{
			$out[] = '</div>
				</div>';
		}

		$out = implode("\n", $out);
	}
	
	function _mail( $params, $field, $record )
	{
		if (! JRequest::getCmd('view'))
		{
			JRequest::setVar('view', 'article');
		}
		global $mainframe;

		$prm = &$mainframe->getParams();
		$article_id = $record->id;
		$id = JRequest::getInt('mail');
		$db = & JFactory::getDBO();
		$from = JRequest::getVar('email_from_' . $id);
		$name = JRequest::getVar('name_' . $id);
		$to = JRequest::getVar('email_to');
		$copy_to = JRequest::getVar('copy_to_sender_' . $id );
		$captcha = JRequest::getVar('module_captcha_text');
		$uri = &JFactory::getURI();
			
		$user = & JFactory::getUser();

		$config = JFactory::getConfig();
		$_from = $config->getValue('config.mailfrom');
		$_name = $config->getValue('config.fromname');

		$query = "SELECT v.id, v.field_value, v.params as vparams, f.params, f.title, f.type, r.user_id, f.id AS field_id
		FROM #__js_res_record_values as v " . ' LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id' . ' LEFT JOIN #__js_res_record AS r ON r.id = v.record_id' . ' WHERE v.record_id = ' . $article_id . ' AND f.published = 1 ' . " AND v.id = '$id'";
		$db->setQuery($query);
		$field = $db->loadObject();
		
		if (! is_object($field) || ! $article_id)
		{
			JError::raiseError(403, JText::_('Cannot send email. Mail information not found'));
			return;
		}

		$params = new JParameter($field->params);

		if ($params->get('show_captcha'))
		{
			if(!$params->get('captcha_type') || ($params->get('captcha_type') && !$user->get('id')))
			{
				require_once JPATH_COMPONENT_SITE . DS . 'library'.DS.'php' . DS . 'securimage.php';
				$img = new securimage();
				if ($img->check(JRequest::getVar('mail_captcha_text'), 'm'.$field->id) == false)
				{
					JError::raiseWarning(100, JText::_('Security spam protection code do not match'));
					return;
				}
			}
		}

		if ($params->get('show_email') && ! JMailHelper::isEmailAddress($from))
		{
			JError::raiseWarning(400, JText::_('Email entered not correctly'));
			return;
		}

		$subject = (JRequest::getVar('subject_' . $id)!='') ? JRequest::getVar('subject_' . $id) : $params->get('subject');
		$message = JRequest::getVar('body_' . $id, $params->get('body'), 'post', 'string', JREQUEST_ALLOWRAW);
		$addFields = JRequest::getVar('add_field', false, 'post', 'string', JREQUEST_ALLOWRAW);

		//$model = JModel::getInstance('Article', 'ResModel');
		$article = $record;

		$body[] = '<table width="100%" cellpadding="2" cellspacing="2">';
		$body[] = '<tr><td>' . JText::_('Page URL') . ': </td><td>' . $uri->toString() . '</td></tr>';
		$body[] = '<tr><td>' . JText::_('Page Title') . ': </td><td>' . $article->title . '</td></tr>';
		$body[] = '<tr><td>' . JText::_('Mail from') . ': </td><td>' . $name . ' (' . $from . ')</td></tr>';
		
		$body[] = '<tr valign="top"><td>' . JText::_('Message') . ': </td><td>' . nl2br($message) . '</td></tr>';

		$correct = true;
		
		if ($params->get('show_add_fields'))
		{
    		if ( $addFields ){
    		    if( !is_array($addFields) )
    		        $addFields = array($addFields);
    		        
    		    $schema = $params->get('additional_fields');  
    		    $add_fields_info = explode(';',trim($schema));
		        foreach ($add_fields_info as $f) {
		        	$field_info = explode(':',$f);
		        	if( count($field_info)>2)
    		            $body[] = '<tr><td>' . JText::_( trim($field_info[2]) ) . ': </td><td>' . ( is_array($addFields[$field_info[1]]) ? implode(',', $addFields[$field_info[1]]) : nl2br($addFields[$field_info[1]])) . '</td></tr>';
    		    }
    		}
		}
		$body[] = '</table>';
		
		$message_type = $params->get('message_type');
		
		if ( $message_type == 0 || $message_type == 2 ) {

    		$mail = JFactory::getMailer();
    		switch ($params->get('to'))
    		{
    			case 1 :
    				$sql = "
    				SELECT v.field_value AS email
    				FROM #__js_res_record_values AS v
    				LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
    				LEFT JOIN #__js_res_record AS r ON r.id = v.record_id
    				WHERE v.record_id = $article_id
    				AND f.type = 'email'";
    				$db->setQuery($sql);
    				$list = $db->loadObjectList();
    
    				if (is_array($list))
    				{
    					foreach($list as $email_to)
    					{
    						$mail->AddAddress($email_to->email);
    					}
    				}
    				break;
    			case 2 :
    				$mail->AddAddress($_from, $_name);
    				break;
    			case 3 :
    				$author = JFactory::getUser($field->user_id);
    				$mail->AddAddress($author->get('email'), $author->get('name'));
    				break;
    			case 4 :
    				if (($params->get('to') == 4) && (! $to || ! JMailHelper::isEmailAddress($to)))
    				{
    					JError::raiseWarning(400, JText::_('Send to email is missing or not correct'));
    					return;
    				}
    				$mail->AddAddress($to);
    				break;
    			case 5 :
    				$mail->AddAddress($params->get('custom'));
    				break;
    					
    			default :
    				break;
    		}
    		$copy_send_msg = '';
    		if ($copy_to)
    		{
    			$mail->AddCC($from);
    			$copy_send_msg = '<li>'.JText::_("Email copy have been sent to sender").'</li>';
    		}
    		
    	    if ($params->get('cc'))
    		{
    		    $cc = JRequest::getVar('cc_' . $id );
    		    $emails = explode(',',$cc);
    		    if($emails && count($emails)>0 ){
    		        foreach ($emails as $e) {
    		        	$mail->AddCC($e);
    		        }
    		    }
    		}
    
    		if ($_FILES['attachment_' . $id]['name'])
    		{
    			$aname = $_FILES['attachment_' . $id]['name'];
    
    			$ext = strtolower(substr($aname, strrpos($aname, '.') + 1));
    			$formats = explode(", ", $params->get('formats'));
    
    			if (! in_array(strtolower($ext), $formats))
    			{
    				JError::raiseWarning(400, JText::_('Could not send mail. Wrong Attachment Format.'));
    				return false;
    			}
    			JFile::copy($_FILES['attachment_' . $id]['tmp_name'], JPATH_CACHE . DS . $aname);
    			$mail->addAttachment(JPATH_CACHE . DS . $aname);
    
    		}
    		if ($from && ! $name)
    		$reply[0] = $from;
    		if ($name && $from)
    		{
    			$reply[0] = $from;
    			$reply[1] = $name;
    		}
    		if (! $reply)
    		{
    			$reply[0] = $_from;
    			$reply[1] = $_name;
    		}
    		$sender[0] = $_from;
    		$sender[1] = $_name;
    
    		$mail->setSender($sender);
    		$mail->addReplyTo($reply);
    		$mail->isHTML(true);
    		$mail->setBody(JMailHelper::cleanBody(implode("\n",  $body)));
    		$mail->setSubject(JMailHelper::cleanSubject($subject));
    
    		if (! $mail->Send())
    		{
    			JError::raiseWarning(400, JText::_('Error: Mail not sent.'));
    			return false;
    		}
		}
		
		if ( $message_type == 1 || $message_type == 2 ) {
		    
		    if( JComponentHelper::isEnabled('com_jsinbox') && $user->get('id')) {
		        if( JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_jsinbox'.DS.'controllers'.DS.'inbox.php')) {
		            
		            $usernames ='';
		            switch ($params->get('to'))
            		{
            			case 1 :
            				$sql = "
            				SELECT u.username 
            				FROM #__users AS u
            				INNER JOIN #__js_res_record_values AS v ON u.email = v.field_value
            				INNER JOIN #__js_res_fields AS f ON f.id = v.field_id
            				INNER JOIN #__js_res_record AS r ON r.id = v.record_id
            				WHERE v.record_id = $article_id
            				AND f.type = 'email'";
            				$db->setQuery($sql);
            				$list = $db->loadResultArray();
            
            				if (is_array($list))
            				{
            					$usernames = implode(',', $list); 
            				}
            				break;
            			case 2 :
            			    $sql = " SELECT u.username FROM #__users AS u WHERE u.email ='". $_from."'";
            				$db->setQuery($sql);
            				$usernames = $db->loadResult();
            				break;
            			case 3 :
            				$author = JFactory::getUser($field->user_id);
            				$usernames = $author->username;
            				break;
            			case 4 :
            				if (($params->get('to') == 4) && (! $to || ! JMailHelper::isEmailAddress($to)))
            				{
            					JError::raiseWarning(400, JText::_('Send to email is missing or not correct'));
            					return;
            				}
            				$sql = " SELECT u.username FROM #__users AS u WHERE u.email ='". $to."'";
            				$db->setQuery($sql);
            				$usernames = $db->loadResult();
            				break;
            			case 5 :
            			    $sql = " SELECT u.username FROM #__users AS u WHERE u.email ='". $params->get('custom')."'";
            				$db->setQuery($sql);
            				$usernames = $db->loadResult();
            				break;
            		}
            		if( $usernames ) {
            		    if( !defined( 'JSPATH_INBOX_ADMIN' ) ) {
                          define( 'JSPATH_INBOX_ADMIN', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jsinbox' );
                        }
                        if( !defined( 'JSPATH_INBOX_SITE' ) ) {
                          define( 'JSPATH_INBOX_SITE', JPATH_SITE.DS.'components'.DS.'com_jsinbox' );
                        }
                        require_once ( JSPATH_INBOX_ADMIN.DS.'controllers'.DS.'cnf.php' );
                        
                        InboxControllerCnf::initialyze();
                        
                        JModel::addIncludePath( JSPATH_INBOX_ADMIN.DS.'models' );
                        JModel::addIncludePath( JSPATH_INBOX_SITE.DS.'models' );
                        JTable::addIncludePath( JSPATH_INBOX_ADMIN.DS.'tables' );
                        JTable::addIncludePath( JSPATH_INBOX_SITE.DS.'tables' );
    		            require_once JPATH_ROOT.DS.'components'.DS.'com_jsinbox'.DS.'controllers'.DS.'inbox.php';
    		            require_once ( JSPATH_INBOX_SITE.DS.'helpers'.DS.'helper.php' );
                        require_once ( JSPATH_INBOX_SITE.DS.'helpers'.DS.'registry.php' );
    		            
    		            $inboxSender = new inboxSender ( );
    		            $inboxSender->user = &$user;
    		            JRequest::setVar('subject', JRequest::getVar('subject_' . $id, JText::_('Without subject')));
    		            JRequest::setVar('body', JMailHelper::cleanBody(implode("\n",  $body)));
    		            JRequest::setVar('attachments', JRequest::getVar('attachment_' . $id, false, 'files'), 'files');
    		            JRequest::setVar('to', $usernames);
            		    if ($params->get('cc'))
                		{
                		    $cc = JRequest::getVar('cc_' . $id );
                		    $emails = explode(',',$cc);
                		    $sql = " SELECT u.username FROM #__users AS u WHERE u.email IN ('". implode("','", $emails)."')";
            				$db->setQuery($sql);
            				$usernames_cc = $db->loadResultArray();
            				JRequest::setVar('cc', implode(',', $usernames_cc));
                		}
    		            JRequest::setVar('task', 'send');
    		            JRequest::setVar('type_id', 1);
    		            $inboxSender->init();
    		            $m_msg = '';
    		            if( $inboxSender->sendMsg() ){
    		                $m_msg = JText::_('Mighty message have been sent successfully');
    		            }
            		}
		        }
		    }
		}
		
	    if ( $params->get('user_subject') == 2 && $params->get('analytics_log')) {
			
			$sql = "INSERT INTO #__js_res_field_extra ".
				"(id, user_id, ref_id, ctime, ip, value, field_id, field_value_id, record_id) ".
				"VALUES (NULL, '{$user->id}', 'email_subject', NOW(), '".$_SERVER['REMOTE_ADDR']."', '".$subject."', ".(int)$field->field_id.','.
			(int)$field->id.','.(int)$article_id.")";
	
			$db->setQuery($sql);
			$db->query();
		}
		
		$mainframe->redirect($uri->toString(), JText::_('Your mail have been sent successfully').$copy_send_msg.$m_msg);
	}
}