<?php
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgJoomsuite_content_fieldsMultipleselect extends JPlugin
{
	function plgJoomsuite_content_fieldMultipleselect( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type )
	{
		if( $type != 'multipleselect' ){return;}
		$values = explode("\n", $params->get('values') ); // values list
		if( $params->get('sort') == 2 ) asort( $values );
		if( $params->get('sort') == 3 ) rsort( $values );		
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = serialize( $def[$obj->id] );
		$default = '';
		$field_value = null;
		if( !empty($obj->field_value) )	{$field_value = unserialize( $obj->field_value );}				
		if( !is_array($field_value) ) $field_value = explode("\n", $params->get('values2') ); // selected list		
		$output = "";
		if( is_array( $values ) && count( $values ) > 0)
		{
			$size = $params->get('size') ? 'size="'.$params->get('size').'"' : '';
			$output .= "<select name='fields[".$obj->id."][]' multiple='multiple' ".$size." >";
			foreach( $values AS $value )
			{ 
				if($value=="")continue;
				$val = explode($params->get('color_separator', "^"), $value);								
				if( @$val[1] ) $color = 'color:'.@$val[1]; else $color = '';
				$selected = ( in_array($value, $field_value) ) ? ' selected="selected" ' : '';
				$val[0] = strip_tags(trim($val[0]));
				$output .= "<option value='".base64_encode( $value )."' ".$selected." style='{$color}'>".JText::_(strip_tags($val[0]))."</option>";				
			}
			$output .= "</select>";			
			;			
		}
		
		if( $params->get('user_value', 1) ){
			$this->userValueScript($obj, $params);
			if( $params->get('user_value_ref', 'text') == 'text'){
				$user_value_text = JText::_($params->get('user_value_text'));
				$output .= "<div><a onclick='showUserValue_".$obj->id."()'>{$user_value_text}</a>";
			} else {
				$output .= "<div><input type='button' value='".JText::_($params->get('user_value_text'))."' onclick='showUserValue_".$obj->id."()'/></div>";
			}			
			#$output .= "<div id='userDiv_{$obj->id}' style='display: none;'><input type='text' name='user_value_{$obj->id}' /></div></div>";
			$output .= "<div id='multi_add_{$obj->id}'></div>";			;
		}
		
		echo $output;
	}
	
	function userValueScript($obj, $params)
	{
		$uid = uniqid(true);
		?>
		<script type="text/javascript" charset="UTF-8">		
		var myvar<?php echo $uid; ?> = 0;		
		function showUserValue_<?php echo $obj->id ?>()
		{
			var limit<?php echo $uid; ?> = <?php echo $params->get('user_value_limit', 5); ?>;
			if(myvar<?php echo $uid; ?> < limit<?php echo $uid; ?>){
				newField_multi = document.createElement("div");
				newField_multi.innerHTML = "<input type='text' name='fields[<?php echo $obj->id ?>][user_value_" + myvar<?php echo $uid; ?> +"][]' id='text_value_<?php echo $obj->id; ?>_"+myvar<?php echo $uid; ?>+"' value=''/>";
					//+"<a onClick='deleteuserfield_<?php echo $obj->id; ?>(text_value_<?php echo $obj->id; ?>_"+myvar<?php echo $uid; ?>+");'>"+
					//"<a onClick='deleteuserfield_<?php echo $obj->id; ?>(text_value_<?php echo $obj->id; ?>_"+myvar<?php echo $uid; ?>+", image_<?php echo $obj->id; ?>_"+myvar<?php echo $uid; ?>+");'>"+
					//"<img src='plugins/joomsuite_content_fields/multipleselect_files/delete.png' id='image_<?php echo $obj->id; ?>_" + myvar<?php echo $uid; ?> + "'/></a>&nbsp;";
					;
				multi_div = document.getElementById("multi_add_<?php echo $obj->id; ?>");
				var parentMultiDiv = multi_div.parentNode;
				parentMultiDiv.insertBefore(newField_multi, multi_div);
				myvar<?php echo $uid; ?>++;
			}			
		}

		function deleteuserfield_<?php echo $obj->id ?>(i)
		{
			//i.parentNode.removeChild( i );
			//j.parentNode.removeChild( j );
			myvar<?php echo $uid; ?>--;	
		}
		
		</script>
		<?php
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if( $type != 'multipleselect' ){return;}
		if( !$value ){	return;	}
		$values  = explode("\n", trim($params->get('values')));
		$value_c = array();
		foreach( $value AS $key => $v)
		{
			if( is_string($v) ){
				$value_c[ $key ] = base64_decode( $v );
			}
		}		
		if( $params->get('user_value', 1) ){
			$user_values = array();
			$user_limit = $params->get('user_value_limit', 5);
			$i = 0;
			foreach($value AS $key => $v ){
				// check existing
				if(is_string($key))
				{
					if(is_array($v) && $i < $user_limit && JString::substr($key, 0, 11) == "user_value_" )
					{
						$user_value = trim($v[0]);
						$user_value_lowercase = JString::strtolower($user_value);
						if ($user_value == "") 
							continue;
						
						$already_exists = false;
						foreach($values AS $val){
							$parts = explode($params->get('color_separator', "^"), $val, 2);
							$val = $parts[0];
							if( JString::strtolower( trim($val) ) == $user_value_lowercase){
								$already_exist = true;
								break;
							}
						}
						
						if( !$already_exists ) {
							$values[] = $user_value;
							$value_c[] = $user_value;
						}
									
						$i++;
					}
				}							
			}
			// add to Value List User value
			if(count($values)){
				JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_resource/tables/');
				// select fields values and insert new user value to params
				$params->set('values', implode('\n', $values));				
				$tField = & JTable::getInstance('Field', 'Table');				
				$tField->load( $id );				
				$tField->set( "params", $params->toString() );
				$tField->store();	
			}
		}
		
		$value = serialize( $value_c );
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(!$field->field_value) return;

		if($field->type != 'multipleselect') return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
	

		$array =  @unserialize($field->field_value);
		if(!is_array($array)) return;

		$params->set('category_id', $category);
		foreach ($array AS $value)
		{
			#$value = base64_encode($value);
			$val = explode($params->get('color_separator', "^"), $value);
			if(@$val[1]) $color = ' style="color:'.@$val[1].'" '; else $color = '';
			$output = "<span{$color}>{$val[0]}</span>";
			$output = ResHelper::cleanFilterValue($output, base64_encode($value), $field, $params, $record);
			$out[] = $output;
		}

		switch ($params->get('separator')) {
			case 1:
				$s = "\n<br>";
				break;
			case 2:
				$s = ", ";
				break;

			case 3:
				$s = ", \n<br>";
				break;
		}
		$out = implode($s, $out);
	}

	function onFilter($out, $type)
	{
		if($type != 'multipleselect') return;
		$out = true;
	}
	
	function onRenderFilter($get, &$filter, $params, $category)
	{
		global $mainframe, $option;
		static $results = array();

		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;

		if($filters_type != 'multipleselect') return;

		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$options = explode("\n", $fparam->get('values'));

		if(is_array($options))
		{
			if($fparam->get('sort') == 2) asort($options);
			if($fparam->get('sort') == 3) rsort($options);

			$list = array();
			$where = getFilterWhere($params);
			foreach ($options AS $opt)
			{
				$val = explode($params->get('color_separator', "^"), $opt);
				if($fparam->get('show_number'))
				{
					$db = & Jfactory::getDBO();

					switch ($params->get('filters_mode', 1))
					{
						case 1:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid = {$category}
							AND fv.field_value LIKE '%{$val[0]}%'
							{$where}
							#GROUP BY r.id";
							break;
						case 3:
							$category = JRequest::getInt('category_id', $category);
							$ids = ResHelper::getCategoryChildrenIds($category);
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid IN ({$ids})
							AND fv.field_value LIKE '%{$val[0]}%'
							{$where}
							#GROUP BY r.id";
							break;
						case 2:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND fv.field_value LIKE '%{$val[0]}%'
							{$where}
							#GROUP BY r.id";
							break;
					}
					if(!key_exists($sql, $results))
					{
						$db->setQuery($sql);
						$num = $db->loadResult();
						$results[$sql] = $num;
					}
					else
					{
						$num = $results[$sql];
					}

					if($num > 0) $list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0])." ({$num})");
					//if($num > 0) $val[0] .= " ({$num})";
				}
				else
				{
					$list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0]));
				}
			}
			$get = $list;
		}
	}
}
?>