<?php
// no direct access
defined('_JEXEC') or die('Restricted Access');

jimport( 'joomla.plugin.plugin' );
require_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

class plgJoomsuite_content_fieldsRadiobutton extends JPlugin
{
	function plgJoomsuite_content_fieldsRadiobutton( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type ){
		if( $type != 'radiobutton' ) return;
		$name = $obj->id;
		$values = explode("\n", $params->get('values') );
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = base64_decode($def[$obj->id]);
		if(!$obj->field_value) $obj->field_value = $params->get('selected');

		//echo htmlspecialchars($obj->field_value);
		//  sorting $values
		if( $params->get('sort') == 2 ) asort( $values );
		if( $params->get('sort') == 3 ) rsort( $values );
		$count = $params->get('column', 1);
		$table_style = $params->get('table_style') ? "style=\"".$params->get('table_style')."\"" : '';
		$output = "<table {$table_style} cellspacing='2' cellpadding='2' border=0>";
		$i = 0;
		$td_style =  $params->get('td_style') ? "style=\"".$params->get('td_style')."\"" : '';
		foreach( $values AS $key => $line ){
			if( $line == "") continue;
			if( $i % $count == 0 ){ $output .= "<tr>"; $tr = $i + $count; }
			$output .= "<td {$td_style}>";
			$val = explode($params->get('color_separator', "^"), $line);
			$color = ( @$val[1] ) ? "style='color:{$val[1]}'" : Null;
			$value = $line;
			$selected = ($obj->field_value == $value) ? "checked='checked'" : Null;
			$value = base64_encode($value);
			#$output .= "<input type='radio' name='fields[{$name}]' id='fields{$name}' value='{$value}' {$selected} onclick='clearUserValue_".$obj->id."()'/>&nbsp;<span {$color}>".JText::_(strip_tags($val[0]))."</span>";
			$output .= "<table><tr>";
			$output .= "<td><input type='radio' name='fields[{$name}]' id='fields{$name}' value='{$value}' {$selected} onclick='clearUserValue_".$obj->id."()'/></td>";
			$output .= "<td><span {$color}>".JText::_( stripslashes ($val[0]) )."</span></td>";
			$output .= "</tr></table>";
			$output .= "</td>";
			if( $i % $count == 0 && $i == $tr ){ $output .= "</tr>"; }
			$i++;
		}
		$output	.= "</table>";

		if( $params->get("user_value", 1) ) {
			$output .= "<input type='radio' name='' onclick='addUserValue_{$obj->id}();' id='fields_{$obj->id}'/>&nbsp;<span id='user_value_label_{$obj->id}'>".JText::_($params->get( "user_value_label" ))."</span>";
			$output .= "<div style='display:none;' id='userVariant_{$obj->id}'><input type='radio'  name='fields[".$name."]' id='user_value_radio_".$name."'/><input type='text' name='user_value_{$name}' id='fields".$obj->id."_user_value'></div>";
			?>
<script type="text/javascript">
					function addUserValue_<?php echo $obj->id ?>()
					{
						// display
						var abba = document.getElementById("userVariant_<?php echo $obj->id; ?>");
						abba.style.display = "block";

						// not display field
						var radioField = document.getElementById( "fields_<?php echo $obj->id; ?>" );
						radioField.style.display = "none";
						
						var user_value_label = document.getElementById( "user_value_label_<?php echo $obj->id; ?>" );
						user_value_label.style.display = "none";
						
						var user_value_radio = document.getElementById("user_value_radio_<?php echo $obj->id ?>");
						user_value_radio.checked = "on";
					}			
					
					function clearUserValue_<?php echo $obj->id ?>()
					{
						var user_value = document.getElementById("fields<?php echo $obj->id; ?>_user_value");
						user_value.value = "";
					}
				</script>
			<?php
			"";			
		}

		echo $output;
	}

	function onBeforeSave( &$value, &$params, $type, $id, $row, &$error )
	{
		if( $type != 'radiobutton' ) return;
		//if( !$value ) return;
		#$user_value = JRequest::getVar("user_value_{$id}");
		$user_value = addslashes(strip_tags($_POST["user_value_{$id}"], "<img>"));
		if( $params->get('user_value',1) AND isset($user_value) AND $user_value )
		{
			$values = explode( "\n", $params->get( 'values' ) );
				
			$user_value = trim($user_value);
			$user_value_lowercase = JString::strtolower($user_value);
			$already_exist = false;

			foreach($values AS $v){
				if( JString::strtolower( trim($v) ) == $user_value_lowercase ){
					$already_exist = true;
					$user_value = $v;
					break;
				}
			}
				
			if ( ! $already_exist ) {
				JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_resource/tables/');
				// select fields values and insert new user value to params
				$values[] = $user_value;
				$params->set('values', implode('\n', $values));
				$tField = & JTable::getInstance('Field', 'Table');
				$tField->load( $id );
				$tField->set( "params", $params->toString() );
				$tField->store();
			}
			$value = trim($user_value);
		} else if( isset( $value ) AND $value ){
			$value = base64_decode(trim($value));
		}
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if( $field->type != 'radiobutton' ) return;
		if( !$field->field_value ) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;

			
		$val = explode($params->get('color_separator', "^"), $field->field_value);
		$color = ( @$val[1] ) ? "style='color:{$val[1]}'" : null;
		$output = stripslashes($val[0]);
		$params->set('category_id', $category);
		$output = ResHelper::cleanFilterValue($output, base64_encode($field->field_value), $field, $params, $record);
		$out = "<span {$color}>{$output}</span>";
	}
	function onFilter($out, $type)
	{
		if($type != 'radiobutton') return;
		$out = true;
	}
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		//echo $type;
		if( $type->type != 'radiobutton' ) return;
		if( !$value ) return;
		//$sql = false;

		$sql = "field_value = '{$value}'";
	}
	function onRenderFilter(&$get, &$filter, &$params, $category)
	{
		global $mainframe, $option;
		static $results = array();

		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;
		$db = & Jfactory::getDBO();
			
		if($filters_type != 'radiobutton') return;

		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$options = explode("\n", $fparam->get('values'));

		if(is_array($options))
		{

			if($fparam->get('sort') == 2) asort($options);
			if($fparam->get('sort') == 3) rsort($options);

			$list = array();
			$where = getFilterWhere($params);
			foreach ($options AS $opt)
			{
				$val = explode($params->get('color_separator', "^"), $opt);
				$opt = $db->getEscaped(stripslashes($opt));

				if($fparam->get('show_number'))
				{
					$db = & Jfactory::getDBO();

					switch ($params->get('filters_mode', 1))
					{
						case 1:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid = {$category}
							AND fv.field_value = '{$opt}'
							{$where}
							#GROUP BY r.id";
							break;
						case 3:
							$category = JRequest::getInt('category_id', $category);
							$ids = ResHelper::getCategoryChildrenIds($category);
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid IN ({$ids})
							AND fv.field_value = '{$opt}'
							{$where}
							#GROUP BY r.id";
							break;
						case 2:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND fv.field_value = '{$opt}'
							{$where}
							#GROUP BY r.id";
							break;
					}
					//echo $sql;
					if(!key_exists($sql, $results))
					{
						$db->setQuery($sql);
						$num = $db->loadResult();
						$results[$sql] = $num;
					}
					else
					{
						$num = $results[$sql];
					}

					if($num > 0) $list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0])." ({$num})");
					//if($num > 0) $val[0] .= " ({$num})";
				}
				else
				{
					$list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0]));
				}
			}
			$get = $list;
		}
	}
}
?>