<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsSeparator extends JPlugin
{
	function plgJoomsuite_content_fieldsSeparator( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'separator') return;

		echo JText::_($params->get('title'));
		echo "<input type=\"hidden\" name=\"fields[{$obj->id}]\" value=\"1\" />";
	}
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'separator') return;
		$value="separator";
	}
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		if($type != 'separator') 		 {return;}
		
		$out = $params->get('title');
		
		$dispatcher =& JDispatcher::getInstance();
		$plugins = $params->get('plugins');
		if($plugins)
		{
			settype($plugins, 'array');
			foreach($plugins as $plugin)
			{
				JPluginHelper::importPlugin('content', $plugin);
			}
			$row->text = $out;
			$dispatcher->trigger('onPrepareContent', array (& $row, $params, JRequest::getInt('limitstart',0)));
			$out = $row->text;
		}
	}

}
?>
